//Software Renderer. Direct port from the BUILD source code

#include "COMMON.H"
#include "MACROS.H"

#define MAXXDIM 1600
#define MAXYDIM 1200
#define MAXWALLSB 2048
#define MAXSTATUS 1024
#define MAXTILES 9216
#define MAXPALOOKUPS 256

#define MAXSECTORS 1024
#define MAXWALLS 8192
#define MAXSPRITES 4096
#define MAXSPRITESONSCREEN 1024
#define MAXPSKYTILES 256

#define MAXNODESPERLINE 42   //Warning: This depends on MAXYSAVES & MAXYDIM!
#define MAXYSAVES ((MAXXDIM*MAXSPRITES)>>7)

extern "C" 
{
	int asm1, asm2, asm3, asm4;
	long ylookup[MAXYDIM+1];
	long vplce[4], vince[4], palookupoffse[4], bufplce[4];
};

//These things were EXTERN'd (TAKEN FROM BUILD.H)
long yxaspect, viewingrange;
long windowx1, windowy1, windowx2, windowy2;
short startumost[MAXXDIM], startdmost[MAXXDIM];
long xdim, ydim, numpages;
long xres, yres, bytesperline, frameplace, imageSize, maxpages;
char vidoption;
char gotsector[(MAXSECTORS+7)>>3];
short headspritesect[MAXSECTORS+1], headspritestat[MAXSTATUS+1];
short prevspritesect[MAXSPRITES], prevspritestat[MAXSPRITES];
short nextspritesect[MAXSPRITES], nextspritestat[MAXSPRITES];
char palookup[0x100][MAXPALOOKUPS];
long visibility, parallaxvisibility;
volatile long totalclock;
long spritesortcnt;
XBUILD_MAP_SPRITE tsprite[MAXSPRITESONSCREEN];
char parallaxtype, showinvisibility;
long parallaxyoffs, parallaxyscale;
short pskyoff[MAXPSKYTILES], pskybits;

short umost[MAXXDIM], dmost[MAXXDIM];
static short bakumost[MAXXDIM], bakdmost[MAXXDIM];
short uplc[MAXXDIM], dplc[MAXXDIM];
static short uwall[MAXXDIM], dwall[MAXXDIM];
static long swplc[MAXXDIM], lplc[MAXXDIM];
static long swall[MAXXDIM], lwall[MAXXDIM+4];
long xdimen = -1, xdimenrecip, halfxdimen, xdimenscale, xdimscale;
long wx1, wy1, wx2, wy2, ydimen;
long viewoffset, frameoffset;
long xyaspect, viewingrangerecip;
long stereowidth = 23040, stereopixelwidth = 28, ostereopixelwidth = -1;
volatile long stereomode = 0, visualpage, activepage, whiteband, blackband;
long transarea = 0, totalarea = 0, beforedrawrooms = 1;
static long xb1[MAXWALLSB], yb1[MAXWALLSB], xb2[MAXWALLSB], yb2[MAXWALLSB];
static long rx1[MAXWALLSB], ry1[MAXWALLSB], rx2[MAXWALLSB], ry2[MAXWALLSB];
static short p2[MAXWALLSB], thesector[MAXWALLSB], thewall[MAXWALLSB];
//long asm1, asm2, asm3, asm4;
char globalxshift, globalyshift;
long globalxpanning, globalypanning, globalshade;
short globalpicnum, globalshiftval;
long globalzd, globalbufplc, globalyscale, globalorientation;
long globalx1, globaly1, globalx2, globaly2, globalx3, globaly3, globalzx;
long globalx, globaly, globalz;
char *globalpalwritten;
static unsigned short sqrtable[4096], shlookup[4096+256];
short sintable[2048];
short radarang[1280];
short radarang2[MAXXDIM];
char textfont[1024];
char smalltextfont[1024];
char britable[1024];
char palette[768];
unsigned short numpalookups = 0;
long globaluclip, globaldclip, globvis;
long globalvisibility, globalhisibility, globalpisibility, globalcisibility;
static char globalpolytype;
long globalposx, globalposy, globalposz, globalhoriz;
char picsiz[MAXTILES];
static short smost[MAXYSAVES], smostcnt;
static short smoststart[MAXWALLSB];
static char smostwalltype[MAXWALLSB];
static long smostwall[MAXWALLSB], smostwallcnt = -1L;
static short *dotp1[MAXYDIM], *dotp2[MAXYDIM];
static long oxdimen = -1, oviewingrange = -1, oxyaspect = -1;
short globalang, globalcursectnum;
long totalclocklock;
long globalpal, cosglobalang, singlobalang;
long cosviewingrangeglobalang, sinviewingrangeglobalang;
static long xsi[8], ysi[8], *horizlookup, *horizlookup2, horizycent;
short numscans, numhits, numbunches;
static short maskwall[MAXWALLSB], maskwallcnt;
char globparaceilclip, globparaflorclip;
static short sectorborder[256], sectorbordercnt;
static short bunchfirst[MAXWALLSB], bunchlast[MAXWALLSB];
static unsigned char tempbuf[MAXWALLS];
short searchit;
long searchx = -1, searchy;                          //search input
short searchsector, searchwall, searchstat;     //search output
long reciptable[2048], fpuasm;
static long lastx[MAXYDIM];
char transluc[0x10000];

char pow2char[8] = 
{
	1,
	2, 
	4, 
	8, 
	16, 
	32, 
	64, 
	128
};

long pow2long[32] =
{
	1L,
	2L,
	4L,
	8L,
	16L,
	32L,
	64L,
	128L,
	256L,
	512L,
	1024L,
	2048L,
	4096L,
	8192L,
	16384L,
	32768L,
	65536L,
	131072L,
	262144L,
	524288L,
	1048576L,
	2097152L,
	4194304L,
	8388608L,
	16777216L,
	33554432L,
	67108864L,
	134217728L,
	268435456L,
	536870912L,
	1073741824L,
	2147483647L,
};

unsigned char *					pVideoBuffer;
XBUILD_MAP						SOFT_Map;
extern XBUILD_ART_TILEDATA*		SOFT_Tiles[MAXTILES];
extern "C" void					hlineasm4(int, int, int, int, int, int);
extern "C" void					mhline(int, int, int, int, int, int);
extern "C" void					thline(int, int, int, int, int, int);
extern "C" void					vlineasm1(int, int, int, int, int, int);
extern "C" void					vlineasm4(int, int);
extern "C" long					prevlineasm1(int, int, int, int, int, int);
extern "C" void					sethlinesizes(int, int, int);
extern "C" void					setuphlineasm4(int, int);
extern "C" void					setpalookupaddress(int);
extern "C" void					msethlineshift(int, int);
extern "C" void					tsethlineshift(int, int);
extern "C" void					setvlinebpl(int);
extern "C" void					setupvlineasm(int);
extern "C" void					fixtransluscence(int);

//Removes 'convertion from x to y can cause data loss'
#pragma warning(disable:4244)

__inline int krecipasm(int a)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov fpuasm, eax;
		fild dword ptr fpuasm;
		add eax, eax;
		fstp dword ptr fpuasm;
		sbb ebx, ebx;
		mov eax, fpuasm;
		mov ecx, eax;
		and eax, 0x007FF000;
		shr eax, 10;
		sub ecx, 0x3F800000;
		shr ecx, 23;
		mov eax, dword ptr reciptable[eax];
		sar eax, cl;
		xor eax, ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int nsqrtasm(int a)
{
	__asm
	{
		mov eax, dword ptr[a];
		test eax, 0xFF000000;
		mov ebx, eax;
		jnz over24;
		shr ebx, 12;
		mov cx, word ptr shlookup[ebx * 2];
		jmp under24;
over24:
		shr ebx, 24;
		mov cx, word ptr shlookup[ebx * 2 + 8192];
under24:
		shr eax, cl;
		mov cl, ch;
		mov ax, word ptr sqrtable[eax * 2];
		shr eax, cl;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int msqrtasm(int a)
{
	__asm
	{
		mov ecx, dword ptr[a];
		mov eax, 0x40000000;
		mov ebx, 0x20000000;
begit:
		cmp ecx, eax;
		jl skip;
		sub ecx, eax;
		lea eax, [eax + ebx * 4];
skip:
		sub eax, ebx;
		shr eax, 1;
		shr ebx, 2;
		jnz begit;
		cmp ecx, eax;
		sbb eax, -1;
		shr eax, 1;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int getclipmask(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov ecx, dword ptr[c];
		mov edx, dword ptr[d];
		sar eax, 31;
		add ebx, ebx;
		adc eax, eax;
		add ecx, ecx;
		adc eax, eax;
		add edx, edx;
		adc eax, eax;
		mov ebx, eax;
		shl ebx, 4;
		or al, 0xF0;
		xor eax, ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline void drawpixel(int nOffset, int nColor)
{
	*(unsigned char*)(nOffset) = nColor;
}

void setaspect(long daxrange, long daaspect)
{
	viewingrange = daxrange;
	viewingrangerecip = divscale32(1L,daxrange);

	yxaspect = daaspect;
	xyaspect = divscale32(1,yxaspect);
	xdimenscale = scale(xdimen,yxaspect,320);
	xdimscale = scale(320,xyaspect,xdimen);
}

void dosetaspect()
{
	long i, j, k, x, y, xinc;

	if (xyaspect != oxyaspect)
	{
		oxyaspect = xyaspect;
		j = xyaspect*320;
		//Here, invalid memory access probably
		horizlookup2[horizycent-1] = divscale26(131072,j);
		for(i=ydim*4-1;i>=0;i--)
			if (i != (horizycent-1))
			{
				horizlookup[i] = divscale28(1,i-(horizycent-1));
				horizlookup2[i] = divscale14(klabs(horizlookup[i]),j);
			}
	}
	if ((xdimen != oxdimen) || (viewingrange != oviewingrange))
	{
		oxdimen = xdimen;
		oviewingrange = viewingrange;
		xinc = mulscale32(viewingrange*320,xdimenrecip);
		x = (640<<16)-mulscale1(xinc,xdimen);
		for(i=0;i<xdimen;i++)
		{
			j = (x&65535); k = (x>>16); x += xinc;
			if (j != 0) j = mulscale16((long)radarang[k+1]-(long)radarang[k],j);
			radarang2[i] = (short)(((long)radarang[k]+j)>>6);
		}
	}
}

short insertspritesect(short sectnum)
{
	short blanktouse;

	if ((sectnum >= MAXSECTORS) || (headspritesect[MAXSECTORS] == -1))
		return(-1);  //list full

	blanktouse = headspritesect[MAXSECTORS];

	headspritesect[MAXSECTORS] = nextspritesect[blanktouse];
	if (headspritesect[MAXSECTORS] >= 0)
		prevspritesect[headspritesect[MAXSECTORS]] = -1;

	prevspritesect[blanktouse] = -1;
	nextspritesect[blanktouse] = headspritesect[sectnum];
	if (headspritesect[sectnum] >= 0)
		prevspritesect[headspritesect[sectnum]] = blanktouse;
	headspritesect[sectnum] = blanktouse;

	SOFT_Map.Sprite[blanktouse].SectorNum = sectnum;

	return(blanktouse);
}

short insertspritestat(short statnum)
{
	short blanktouse;

	if ((statnum >= MAXSTATUS) || (headspritestat[MAXSTATUS] == -1))
		return(-1);  //list full

	blanktouse = headspritestat[MAXSTATUS];

	headspritestat[MAXSTATUS] = nextspritestat[blanktouse];
	if (headspritestat[MAXSTATUS] >= 0)
		prevspritestat[headspritestat[MAXSTATUS]] = -1;

	prevspritestat[blanktouse] = -1;
	nextspritestat[blanktouse] = headspritestat[statnum];
	if (headspritestat[statnum] >= 0)
		prevspritestat[headspritestat[statnum]] = blanktouse;
	headspritestat[statnum] = blanktouse;

	SOFT_Map.Sprite[blanktouse].StatNum = statnum;

	return(blanktouse);
}

short insertsprite(short sectnum, short statnum)
{
	insertspritestat(statnum);
	return(insertspritesect(sectnum));
}

void initspritelists()
{
	long i;

	for (i=0;i<MAXSECTORS;i++)     //Init doubly-linked sprite sector lists
		headspritesect[i] = -1;
	headspritesect[MAXSECTORS] = 0;
	for(i=0;i<MAXSPRITES;i++)
	{
		prevspritesect[i] = i-1;
		nextspritesect[i] = i+1;
		SOFT_Map.Sprite[i].SectorNum = MAXSECTORS;
	}
	prevspritesect[0] = -1;
	nextspritesect[MAXSPRITES-1] = -1;


	for(i=0;i<MAXSTATUS;i++)      //Init doubly-linked sprite status lists
		headspritestat[i] = -1;
	headspritestat[MAXSTATUS] = 0;
	for(i=0;i<MAXSPRITES;i++)
	{
		prevspritestat[i] = i-1;
		nextspritestat[i] = i+1;
		SOFT_Map.Sprite[i].StatNum = MAXSTATUS;
	}
	prevspritestat[0] = -1;
	nextspritestat[MAXSPRITES-1] = -1;
}

void initengine()
{
//	long i, j;

//	if (dommxoverlay) mmxoverlay();

//	loadtables();

	xyaspect = -1;

	pskyoff[0] = 0; pskybits = 0;

	parallaxtype = 2; parallaxyoffs = 0L; parallaxyscale = 65536;
	showinvisibility = 0;

//	paletteloaded = 0;

//	searchit = 0; searchstat = -1;

/*	clearbuf((long)(&waloff[0]),(long)MAXTILES,0L);

	clearbuf((long)(&show2dsector[0]),(long)((MAXSECTORS+3)>>5),0L);
	clearbuf((long)(&show2dsprite[0]),(long)((MAXSPRITES+3)>>5),0L);
	clearbuf((long)(&show2dwall[0]),(long)((MAXWALLS+3)>>5),0L);*/
//	automapping = 0;

//	validmodecnt = 0;

//	pointhighlight = -1;
//	linehighlight = -1;
//	highlightcnt = 0;

	totalclock = 0;
	visibility = 512;
	parallaxvisibility = 512;

//	loadpalette();
}

void setview(long x1, long y1, long x2, long y2)
{
	long i;

	windowx1 = x1; wx1 = (x1<<12);
	windowy1 = y1; wy1 = (y1<<12);
	windowx2 = x2; wx2 = ((x2+1)<<12);
	windowy2 = y2; wy2 = ((y2+1)<<12);

	xdimen = (x2-x1)+1; halfxdimen = (xdimen>>1);
	xdimenrecip = divscale32(1L,xdimen);
	ydimen = (y2-y1)+1;

	initengine();
	setaspect(65536L,(long)divscale16(ydim*320L,xdim*200L));

	for(i=0;i<windowx1;i++) { startumost[i] = 1, startdmost[i] = 0; }
	for(i=windowx1;i<=windowx2;i++)
		{ startumost[i] = windowy1, startdmost[i] = windowy2+1; }
	for(i=windowx2+1;i<xdim;i++) { startumost[i] = 1, startdmost[i] = 0; }

	viewoffset = windowy1*bytesperline + windowx1;

	if ((stereomode) || (vidoption == 6))
	{
		ostereopixelwidth = stereopixelwidth;
		xdimen = (windowx2-windowx1+1)+(stereopixelwidth<<1); halfxdimen = (xdimen>>1);
		xdimenrecip = divscale32(1L,xdimen);
		setaspect((long)divscale16(xdimen,windowx2-windowx1+1),yxaspect);
	}
}

void inittables()
{
	unsigned _int8 *pTable;
	unsigned _int32 dwSize;
	long i, j, k;
	XBUILD_GRPMANAGER_GetFileData("TABLES.DAT", &pTable, &dwSize);
	if(pTable == NULL)
	{
		//We should have a better error handing here
		return;
	}
	for(i=0;i<2048;i++) reciptable[i] = divscale30(2048L,i+2048);
	memcpy(sintable, pTable, 2048 * 2);
	memcpy(radarang, pTable + 4096, 640 * 2);
	for(i = 0; i < 640; i++) 
	{
		radarang[1279-i] = -radarang[i];
	}
	memcpy(textfont, pTable + 5376, 1024);
	memcpy(smalltextfont, pTable + 6400, 1024);
	memcpy(britable, pTable + 7424, 1024);
	XBUILD_GRPMANAGER_GetFileData("PALETTE.DAT", &pTable, &dwSize);
	memcpy(palette, pTable, 0x300);
	numpalookups = *(unsigned short*)(pTable + 0x300);
	for(i = 0; i < numpalookups; i++)
	{
		memcpy(palookup[i], pTable + 0x302 + (i * 0x100), 0x100);
	}
	memcpy(transluc, pTable + 0x302 + (numpalookups * 0x100), 0x10000);
	fixtransluscence((int)&transluc[0]);
	j = 1; k = 0;
	for(i=0;i<4096;i++)
	{
		if (i >= j) { j <<= 2; k++; }
		sqrtable[i] = (unsigned short)(msqrtasm((i<<18)+131072)<<1);
		shlookup[i] = (k<<1)+((10-k)<<8);
		if (i < 256) shlookup[i+4096] = ((k+6)<<1)+((10-(k+6))<<8);
	}
	memset(&smost, 0, MAXYSAVES * 2);
}

//Different Version (not taken from BUILD source)
int setgamemode(long cx, long cy)
{
	int i, j;
	xdim = cx;
	ydim = cy;
	bytesperline = cx;
	stereomode = 0;
	inittables();
	pVideoBuffer = new unsigned char[cx * cy * 2];
	memset(pVideoBuffer, 0, cx * cy * 2);
	frameplace = (long)pVideoBuffer;
	j = ydim * 4 * sizeof(long);
	i = xdim * ydim;
	horizlookup = (long *)(frameplace+i);
	horizlookup2 = (long*)(frameplace+i+j);
	j = 0;
	for(i=0;i<=ydim;i++) ylookup[i] = j, j += bytesperline;
	setvlinebpl(bytesperline);
//These vars could be important...
	horizycent = ((ydim*4)>>1);
	oxyaspect = oxdimen = oviewingrange = -1;
//	qsetmode = 200;
	setview(0, 0, cx - 1, cy - 1);
	return 0;
}

void drawline256 (long x1, long y1, long x2, long y2, char col)
{
	long dx, dy, i, j, p, inc, plc, daend;

	col = palookup[0][col];

	dx = x2-x1; dy = y2-y1;
	if (dx >= 0)
	{
		if ((x1 >= wx2) || (x2 < wx1)) return;
		if (x1 < wx1) y1 += scale(wx1-x1,dy,dx), x1 = wx1;
		if (x2 > wx2) y2 += scale(wx2-x2,dy,dx), x2 = wx2;
	}
	else
	{
		if ((x2 >= wx2) || (x1 < wx1)) return;
		if (x2 < wx1) y2 += scale(wx1-x2,dy,dx), x2 = wx1;
		if (x1 > wx2) y1 += scale(wx2-x1,dy,dx), x1 = wx2;
	}
	if (dy >= 0)
	{
		if ((y1 >= wy2) || (y2 < wy1)) return;
		if (y1 < wy1) x1 += scale(wy1-y1,dx,dy), y1 = wy1;
		if (y2 > wy2) x2 += scale(wy2-y2,dx,dy), y2 = wy2;
	}
	else
	{
		if ((y2 >= wy2) || (y1 < wy1)) return;
		if (y2 < wy1) x2 += scale(wy1-y2,dx,dy), y2 = wy1;
		if (y1 > wy2) x1 += scale(wy2-y1,dx,dy), y1 = wy2;
	}

	if (klabs(dx) >= klabs(dy))
	{
		if (dx == 0) return;
		if (dx < 0)
		{
			i = x1; x1 = x2; x2 = i;
			i = y1; y1 = y2; y2 = i;
		}

		inc = divscale12(dy,dx);
		plc = y1+mulscale12((2047-x1)&4095,inc);
		i = ((x1+2048)>>12); daend = ((x2+2048)>>12);
		for(;i<daend;i++)
		{
			j = (plc>>12);
			if ((j >= startumost[i]) && (j < startdmost[i]))
				drawpixel(ylookup[j]+i+frameplace,col);
			plc += inc;
		}
	}
	else
	{
		if (dy < 0)
		{
			i = x1; x1 = x2; x2 = i;
			i = y1; y1 = y2; y2 = i;
		}

		inc = divscale12(dx,dy);
		plc = x1+mulscale12((2047-y1)&4095,inc);
		i = ((y1+2048)>>12); daend = ((y2+2048)>>12);
		p = ylookup[i]+frameplace;
		for(;i<daend;i++)
		{
			j = (plc>>12);
			if ((i >= startumost[j]) && (i < startdmost[j]))
				drawpixel(j+p,col);
			plc += inc; p += ylookup[1];
		}
	}
}

void printext256(long xpos, long ypos, short col, short backcol, char name[82], char fontsize)
{
	long stx, i, x, y, charxsiz;
	char *fontptr, *letptr, *ptr;

	stx = xpos;

	if (fontsize) { fontptr = smalltextfont; charxsiz = 4; }
				else { fontptr = textfont; charxsiz = 8; }

	for(i=0;name[i];i++)
	{
		letptr = &fontptr[name[i]<<3];
		ptr = (char *)(ylookup[ypos+7]+(stx-fontsize)+frameplace);
		for(y=7;y>=0;y--)
		{
			for(x=charxsiz-1;x>=0;x--)
			{
				if (letptr[y]&pow2char[7-fontsize-x])
					ptr[x] = (char)col;
				else if (backcol >= 0)
					ptr[x] = (char)backcol;
			}
			ptr -= ylookup[1];
		}
		stx += charxsiz;
	}
}

int clippoly (long npoints, long clipstat)
{
	long z, zz, s1, s2, t, npoints2, start2, z1, z2, z3, z4, splitcnt;
	long cx1, cy1, cx2, cy2;

	cx1 = windowx1;
	cy1 = windowy1;
	cx2 = windowx2+1;
	cy2 = windowy2+1;
	cx1 <<= 12; cy1 <<= 12; cx2 <<= 12; cy2 <<= 12;

	if (clipstat&0xa)   //Need to clip top or left
	{
		npoints2 = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = cx1-rx1[z];
			do
			{
				zz = xb1[z]; xb1[z] = -1;
				s1 = s2; s2 = cx1-rx1[zz];
				if (s1 < 0)
				{
					rx2[npoints2] = rx1[z]; ry2[npoints2] = ry1[z];
					xb2[npoints2] = npoints2+1; npoints2++;
				}
				if ((s1^s2) < 0)
				{
					rx2[npoints2] = rx1[z]+scale(rx1[zz]-rx1[z],s1,s1-s2);
					ry2[npoints2] = ry1[z]+scale(ry1[zz]-ry1[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints2;
					xb2[npoints2] = npoints2+1;
					npoints2++;
				}
				z = zz;
			} while (xb1[z] >= 0);

			if (npoints2 >= start2+3)
				xb2[npoints2-1] = start2, start2 = npoints2;
			else
				npoints2 = start2;

			z = 1;
			while ((z < npoints) && (xb1[z] < 0)) z++;
		} while (z < npoints);
		if (npoints2 <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb2[z1]; z3 = p2[zz]; z4 = xb2[z3];
				s1  = klabs(rx2[z1]-rx2[z2])+klabs(ry2[z1]-ry2[z2]);
				s1 += klabs(rx2[z3]-rx2[z4])+klabs(ry2[z3]-ry2[z4]);
				s2  = klabs(rx2[z1]-rx2[z4])+klabs(ry2[z1]-ry2[z4]);
				s2 += klabs(rx2[z3]-rx2[z2])+klabs(ry2[z3]-ry2[z2]);
				if (s2 < s1)
					{ t = xb2[p2[z]]; xb2[p2[z]] = xb2[p2[zz]]; xb2[p2[zz]] = t; }
			}


		npoints = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = cy1-ry2[z];
			do
			{
				zz = xb2[z]; xb2[z] = -1;
				s1 = s2; s2 = cy1-ry2[zz];
				if (s1 < 0)
				{
					rx1[npoints] = rx2[z]; ry1[npoints] = ry2[z];
					xb1[npoints] = npoints+1; npoints++;
				}
				if ((s1^s2) < 0)
				{
					rx1[npoints] = rx2[z]+scale(rx2[zz]-rx2[z],s1,s1-s2);
					ry1[npoints] = ry2[z]+scale(ry2[zz]-ry2[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints;
					xb1[npoints] = npoints+1;
					npoints++;
				}
				z = zz;
			} while (xb2[z] >= 0);

			if (npoints >= start2+3)
				xb1[npoints-1] = start2, start2 = npoints;
			else
				npoints = start2;

			z = 1;
			while ((z < npoints2) && (xb2[z] < 0)) z++;
		} while (z < npoints2);
		if (npoints <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb1[z1]; z3 = p2[zz]; z4 = xb1[z3];
				s1  = klabs(rx1[z1]-rx1[z2])+klabs(ry1[z1]-ry1[z2]);
				s1 += klabs(rx1[z3]-rx1[z4])+klabs(ry1[z3]-ry1[z4]);
				s2  = klabs(rx1[z1]-rx1[z4])+klabs(ry1[z1]-ry1[z4]);
				s2 += klabs(rx1[z3]-rx1[z2])+klabs(ry1[z3]-ry1[z2]);
				if (s2 < s1)
					{ t = xb1[p2[z]]; xb1[p2[z]] = xb1[p2[zz]]; xb1[p2[zz]] = t; }
			}
	}
	if (clipstat&0x5)   //Need to clip bottom or right
	{
		npoints2 = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = rx1[z]-cx2;
			do
			{
				zz = xb1[z]; xb1[z] = -1;
				s1 = s2; s2 = rx1[zz]-cx2;
				if (s1 < 0)
				{
					rx2[npoints2] = rx1[z]; ry2[npoints2] = ry1[z];
					xb2[npoints2] = npoints2+1; npoints2++;
				}
				if ((s1^s2) < 0)
				{
					rx2[npoints2] = rx1[z]+scale(rx1[zz]-rx1[z],s1,s1-s2);
					ry2[npoints2] = ry1[z]+scale(ry1[zz]-ry1[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints2;
					xb2[npoints2] = npoints2+1;
					npoints2++;
				}
				z = zz;
			} while (xb1[z] >= 0);

			if (npoints2 >= start2+3)
				xb2[npoints2-1] = start2, start2 = npoints2;
			else
				npoints2 = start2;

			z = 1;
			while ((z < npoints) && (xb1[z] < 0)) z++;
		} while (z < npoints);
		if (npoints2 <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb2[z1]; z3 = p2[zz]; z4 = xb2[z3];
				s1  = klabs(rx2[z1]-rx2[z2])+klabs(ry2[z1]-ry2[z2]);
				s1 += klabs(rx2[z3]-rx2[z4])+klabs(ry2[z3]-ry2[z4]);
				s2  = klabs(rx2[z1]-rx2[z4])+klabs(ry2[z1]-ry2[z4]);
				s2 += klabs(rx2[z3]-rx2[z2])+klabs(ry2[z3]-ry2[z2]);
				if (s2 < s1)
					{ t = xb2[p2[z]]; xb2[p2[z]] = xb2[p2[zz]]; xb2[p2[zz]] = t; }
			}


		npoints = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = ry2[z]-cy2;
			do
			{
				zz = xb2[z]; xb2[z] = -1;
				s1 = s2; s2 = ry2[zz]-cy2;
				if (s1 < 0)
				{
					rx1[npoints] = rx2[z]; ry1[npoints] = ry2[z];
					xb1[npoints] = npoints+1; npoints++;
				}
				if ((s1^s2) < 0)
				{
					rx1[npoints] = rx2[z]+scale(rx2[zz]-rx2[z],s1,s1-s2);
					ry1[npoints] = ry2[z]+scale(ry2[zz]-ry2[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints;
					xb1[npoints] = npoints+1;
					npoints++;
				}
				z = zz;
			} while (xb2[z] >= 0);

			if (npoints >= start2+3)
				xb1[npoints-1] = start2, start2 = npoints;
			else
				npoints = start2;

			z = 1;
			while ((z < npoints2) && (xb2[z] < 0)) z++;
		} while (z < npoints2);
		if (npoints <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb1[z1]; z3 = p2[zz]; z4 = xb1[z3];
				s1  = klabs(rx1[z1]-rx1[z2])+klabs(ry1[z1]-ry1[z2]);
				s1 += klabs(rx1[z3]-rx1[z4])+klabs(ry1[z3]-ry1[z4]);
				s2  = klabs(rx1[z1]-rx1[z4])+klabs(ry1[z1]-ry1[z4]);
				s2 += klabs(rx1[z3]-rx1[z2])+klabs(ry1[z3]-ry1[z2]);
				if (s2 < s1)
					{ t = xb1[p2[z]]; xb1[p2[z]] = xb1[p2[zz]]; xb1[p2[zz]] = t; }
			}
	}
	return(npoints);
}

void fillpolygon(long npoints)
{
	long z, zz, zzz, x1, y1, x2, y2, miny, maxy, x, y, xinc, cnt;
	long ox, oy, bx, by, bxinc, byinc, xend, p, r, day1, day2;
	short *ptr, *ptr2;

	miny = 0x7fffffff; maxy = 0x80000000;
	for(z=npoints-1;z>=0;z--)
		{ y = ry1[z]; miny = min(miny,y); maxy = max(maxy,y); }
	miny = (miny>>12); maxy = (maxy>>12);
	if (miny < 0) miny = 0;
	if (maxy >= ydim) maxy = ydim-1;
	ptr = smost;    //They're pointers! - watch how you optimize this thing
	for(y=miny;y<=maxy;y++)
	{
		dotp1[y] = ptr; dotp2[y] = ptr+(MAXNODESPERLINE>>1);
		ptr += MAXNODESPERLINE;
	}

	for(z=npoints-1;z>=0;z--)
	{
		zz = xb1[z];
		y1 = ry1[z]; day1 = (y1>>12);
		y2 = ry1[zz]; day2 = (y2>>12);
		if (day1 != day2)
		{
			x1 = rx1[z]; x2 = rx1[zz];
			xinc = divscale12(x2-x1,y2-y1);
			if (day2 > day1)
			{
				x1 += mulscale12((day1<<12)+4095-y1,xinc);
				for(y=day1;y<day2;y++) { *dotp2[y]++ = (x1>>12); x1 += xinc; }
			}
			else
			{
				x2 += mulscale12((day2<<12)+4095-y2,xinc);
				for(y=day2;y<day1;y++) { *dotp1[y]++ = (x2>>12); x2 += xinc; }
			}
		}
	}

	globalx1 = mulscale16(globalx1,xyaspect);
	globaly2 = mulscale16(globaly2,xyaspect);

	oy = miny+1-(ydim>>1);
	globalposx += oy*globalx1;
	globalposy += oy*globaly2;

	setuphlineasm4(asm1,asm2);

	ptr = smost;
	for(y=miny;y<=maxy;y++)
	{
		cnt = dotp1[y]-ptr; ptr2 = ptr+(MAXNODESPERLINE>>1);
		for(z=cnt-1;z>=0;z--)
		{
			day1 = 0; day2 = 0;
			for(zz=z;zz>0;zz--)
			{
				if (ptr[zz] < ptr[day1]) day1 = zz;
				if (ptr2[zz] < ptr2[day2]) day2 = zz;
			}
			x1 = ptr[day1]; ptr[day1] = ptr[z];
			x2 = ptr2[day2]-1; ptr2[day2] = ptr2[z];
			if (x1 > x2) continue;

			if (globalpolytype < 1)
			{
					//maphline
				ox = x2+1-(xdim>>1);
				bx = ox*asm1 + globalposx;
				by = ox*asm2 - globalposy;
				p = ylookup[y]+x2+frameplace;
				hlineasm4(x2-x1,-1L,globalshade<<8,by,bx,p);
			}
			else
			{
					//maphline
				ox = x1+1-(xdim>>1);
				bx = ox*asm1 + globalposx;
				by = ox*asm2 - globalposy;

				p = ylookup[y]+x1+frameplace;
				if (globalpolytype == 1)
				{
					mhline(globalbufplc,bx,(x2-x1)<<16,0L,by,p);
				}
				else
				{
					thline(globalbufplc,bx,(x2-x1)<<16,0L,by,p);
					transarea += (x2-x1);
				}
			}
		}
		globalposx += globalx1;
		globalposy += globaly2;
		ptr += MAXNODESPERLINE;
	}
}

void drawmapview (long dax, long day, long zoome, short ang)
{
	XBUILD_MAP_WALL *wal;
	XBUILD_MAP_SECTOR *sec;
	XBUILD_MAP_SPRITE *spr;
	long tilenum, xoff, yoff, i, j, k, l, cosang, sinang, xspan, yspan;
	long xrepeat, yrepeat, x, y, x1, y1, x2, y2, x3, y3, x4, y4, bakx1, baky1;
	long s, w, ox, oy, startwall, cx1, cy1, cx2, cy2;
	long bakgxvect, bakgyvect, sortnum, gap, npoints;
	long xvect, yvect, xvect2, yvect2, daslope;

	beforedrawrooms = 0;
	totalarea += (windowx2+1-windowx1)*(windowy2+1-windowy1);

	memset(&gotsector[0], 0, (long)((SOFT_Map.Mapinfo.SectorNumber+31)>>5));

	cx1 = (windowx1<<12); cy1 = (windowy1<<12);
	cx2 = ((windowx2+1)<<12)-1; cy2 = ((windowy2+1)<<12)-1;
	zoome <<= 8;
	bakgxvect = divscale28(sintable[(1536-ang)&2047],zoome);
	bakgyvect = divscale28(sintable[(2048-ang)&2047],zoome);
	xvect = mulscale8(sintable[(2048-ang)&2047],zoome);
	yvect = mulscale8(sintable[(1536-ang)&2047],zoome);
	xvect2 = mulscale16(xvect,yxaspect);
	yvect2 = mulscale16(yvect,yxaspect);

	sortnum = 0;
	for(s=0,sec=&SOFT_Map.Sector[s];s<SOFT_Map.Mapinfo.SectorNumber;s++,sec++)
		//TODO: Add this functionnality
		//if (show2dsector[s>>3]&pow2char[s&7])		This has something do to with already "seen" sectors
		{
			npoints = 0; i = 0;
			startwall = sec->WallPointer;
			for(w=sec->WallNumber,wal=&SOFT_Map.Wall[startwall];w>0;w--,wal++)
			{
				ox = wal->X - dax; oy = wal->Y - day;
				x = dmulscale16(ox,xvect,-oy,yvect) + (xdim<<11);
				y = dmulscale16(oy,xvect2,ox,yvect2) + (ydim<<11);
				i |= getclipmask(x-cx1,cx2-x,y-cy1,cy2-y);
				rx1[npoints] = x;
				ry1[npoints] = y;
				xb1[npoints] = wal->Point2 - startwall;
				npoints++;
			}
			if ((i&0xf0) != 0xf0) continue;
			bakx1 = rx1[0]; baky1 = mulscale16(ry1[0]-(ydim<<11),xyaspect)+(ydim<<11);
			if (i&0x0f)
			{
				npoints = clippoly(npoints,i);
				if (npoints < 3) continue;
			}

			//Collect floor sprites to draw
			for(i=headspritesect[s];i>=0;i=nextspritesect[i])
				if ((SOFT_Map.Sprite[i].CStat&48) == 32)
				{
					if ((SOFT_Map.Sprite[i].CStat&(64+8)) == (64+8)) continue;
					tsprite[sortnum++].Owner = i;
				}

			gotsector[s>>3] |= pow2char[s&7];

			globalorientation = (long)sec->FStat;
			if ((globalorientation&1) != 0) continue;

			if (palookup[sec->FPal] != globalpalwritten)
			{
				globalpalwritten = palookup[sec->FPal];
				setpalookupaddress((int)globalpalwritten);
			}
			globalpicnum = sec->FPic;
			if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
			//This has something to do with tile allocation
			//setgotpic(globalpicnum);
			if(SOFT_Tiles[globalpicnum] == NULL)
			{
				SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
				XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
				j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
				picsiz[globalpicnum] = ((char)j);
				j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
				picsiz[globalpicnum] += ((char)(j<<4));
			}
			if ((SOFT_Tiles[globalpicnum]->Width <= 0) || (SOFT_Tiles[globalpicnum]->Height <= 0)) continue;
			//TODO: Modify this to make it support our animation engine
			//if ((picanm[globalpicnum]&192) != 0) globalpicnum += animateoffs((short)globalpicnum,s);
			//if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
			//globalbufplc = waloff[globalpicnum];
			globalbufplc = (long)SOFT_Tiles[globalpicnum]->lpData;
			globalshade = max(min(sec->FShade,numpalookups-1),0);
			globvis = globalhisibility;
			if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));
			globalpolytype = 0;
			if ((globalorientation&64) == 0)
			{
				globalposx = dax; globalx1 = bakgxvect; globaly1 = bakgyvect;
				globalposy = day; globalx2 = bakgxvect; globaly2 = bakgyvect;
			}
			else
			{
				ox = SOFT_Map.Wall[SOFT_Map.Wall[startwall].Point2].X - SOFT_Map.Wall[startwall].X;
				oy = SOFT_Map.Wall[SOFT_Map.Wall[startwall].Point2].Y - SOFT_Map.Wall[startwall].Y;
				i = nsqrtasm(ox*ox+oy*oy); if (i == 0) continue;
				i = 1048576/i;
				globalx1 = mulscale10(dmulscale10(ox,bakgxvect,oy,bakgyvect),i);
				globaly1 = mulscale10(dmulscale10(ox,bakgyvect,-oy,bakgxvect),i);
				ox = (bakx1>>4)-(xdim<<7); oy = (baky1>>4)-(ydim<<7);
				globalposx = dmulscale28(-oy,globalx1,-ox,globaly1);
				globalposy = dmulscale28(-ox,globalx1,oy,globaly1);
				globalx2 = -globalx1;
				globaly2 = -globaly1;

				daslope = SOFT_Map.Sector[s].FHei;
				i = nsqrtasm(daslope*daslope+16777216);
				globalposy = mulscale12(globalposy,i);
				globalx2 = mulscale12(globalx2,i);
				globaly2 = mulscale12(globaly2,i);
			}
			globalxshift = (8-(picsiz[globalpicnum]&15));
			globalyshift = (8-(picsiz[globalpicnum]>>4));
			if (globalorientation&8) {globalxshift++; globalyshift++; }

			sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4,globalbufplc);

			if ((globalorientation&0x4) > 0)
			{
				i = globalposx; globalposx = -globalposy; globalposy = -i;
				i = globalx2; globalx2 = globaly1; globaly1 = i;
				i = globalx1; globalx1 = -globaly2; globaly2 = -i;
			}
			if ((globalorientation&0x10) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalposx = -globalposx;
			if ((globalorientation&0x20) > 0) globalx2 = -globalx2, globaly2 = -globaly2, globalposy = -globalposy;
			asm1 = (globaly1<<globalxshift);
			asm2 = (globalx2<<globalyshift);
			globalx1 <<= globalxshift;
			globaly2 <<= globalyshift;
			globalposx = (globalposx<<(20+globalxshift))+(((long)sec->FPanX)<<24);
			globalposy = (globalposy<<(20+globalyshift))-(((long)sec->FPanY)<<24);

			fillpolygon(npoints);
		}

		//Sort sprite list
	gap = 1; while (gap < sortnum) gap = (gap<<1)+1;
	for(gap>>=1;gap>0;gap>>=1)
		for(i=0;i<sortnum-gap;i++)
			for(j=i;j>=0;j-=gap)
			{
				if (SOFT_Map.Sprite[tsprite[j].Owner].Z <= SOFT_Map.Sprite[tsprite[j+gap].Owner].Z) break;
				swapshort((int*)&tsprite[j].Owner,(int*)&tsprite[j+gap].Owner);
			}

	for(s=sortnum-1;s>=0;s--)
	{
		spr = &SOFT_Map.Sprite[tsprite[s].Owner];
		if ((spr->CStat&48) == 32)
		{
			npoints = 0;

			tilenum = spr->Pic;
			//xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
			//yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);
			xoff = (long)spr->OffX;
			yoff = (long)spr->OffY;
			if ((spr->CStat&4) > 0) xoff = -xoff;
			if ((spr->CStat&8) > 0) yoff = -yoff;

			if(SOFT_Tiles[tilenum] == NULL)
			{
				SOFT_Tiles[tilenum] = new XBUILD_ART_TILEDATA;
				XBUILD_ART_GetTileData(tilenum, SOFT_Tiles[tilenum]);
				j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
				picsiz[globalpicnum] = ((char)j);
				j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
				picsiz[globalpicnum] += ((char)(j<<4));
			}

			k = spr->Angle;
			cosang = sintable[(k+512)&2047]; sinang = sintable[k];
			xspan = SOFT_Tiles[tilenum]->Width;		xrepeat = spr->RepX;
			yspan = SOFT_Tiles[tilenum]->Height;	yrepeat = spr->RepY;

			ox = ((xspan>>1)+xoff)*xrepeat; oy = ((yspan>>1)+yoff)*yrepeat;
			x1 = spr->X + mulscale(sinang,ox,16) + mulscale(cosang,oy,16);
			y1 = spr->Y + mulscale(sinang,oy,16) - mulscale(cosang,ox,16);
			l = xspan*xrepeat;
			x2 = x1 - mulscale(sinang,l,16);
			y2 = y1 + mulscale(cosang,l,16);
			l = yspan*yrepeat;
			k = -mulscale(cosang,l,16); x3 = x2+k; x4 = x1+k;
			k = -mulscale(sinang,l,16); y3 = y2+k; y4 = y1+k;

			xb1[0] = 1; xb1[1] = 2; xb1[2] = 3; xb1[3] = 0;
			npoints = 4;

			i = 0;

			ox = x1 - dax; oy = y1 - day;
			x = dmulscale16(ox,xvect,-oy,yvect) + (xdim<<11);
			y = dmulscale16(oy,xvect2,ox,yvect2) + (ydim<<11);
			i |= getclipmask(x-cx1,cx2-x,y-cy1,cy2-y);
			rx1[0] = x; ry1[0] = y;

			ox = x2 - dax; oy = y2 - day;
			x = dmulscale16(ox,xvect,-oy,yvect) + (xdim<<11);
			y = dmulscale16(oy,xvect2,ox,yvect2) + (ydim<<11);
			i |= getclipmask(x-cx1,cx2-x,y-cy1,cy2-y);
			rx1[1] = x; ry1[1] = y;

			ox = x3 - dax; oy = y3 - day;
			x = dmulscale16(ox,xvect,-oy,yvect) + (xdim<<11);
			y = dmulscale16(oy,xvect2,ox,yvect2) + (ydim<<11);
			i |= getclipmask(x-cx1,cx2-x,y-cy1,cy2-y);
			rx1[2] = x; ry1[2] = y;

			x = rx1[0]+rx1[2]-rx1[1];
			y = ry1[0]+ry1[2]-ry1[1];
			i |= getclipmask(x-cx1,cx2-x,y-cy1,cy2-y);
			rx1[3] = x; ry1[3] = y;

			if ((i&0xf0) != 0xf0) continue;
			bakx1 = rx1[0]; baky1 = mulscale16(ry1[0]-(ydim<<11),xyaspect)+(ydim<<11);
			if (i&0x0f)
			{
				npoints = clippoly(npoints,i);
				if (npoints < 3) continue;
			}

			globalpicnum = spr->Pic;
			if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
			//setgotpic(globalpicnum);
			if ((SOFT_Tiles[globalpicnum]->Width <= 0) || (SOFT_Tiles[globalpicnum]->Height <= 0)) continue;
			//Animation System
			//if ((picanm[globalpicnum]&192) != 0) globalpicnum += animateoffs((short)globalpicnum,s);
			//Tile already loaded
			//if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
			globalbufplc = (long)SOFT_Tiles[globalpicnum]->lpData;
			if ((SOFT_Map.Sector[spr->SectorNum].CStat&1) > 0)
				globalshade = ((long)SOFT_Map.Sector[spr->SectorNum].CShade);
			else
				globalshade = ((long)SOFT_Map.Sector[spr->SectorNum].FShade);
			globalshade = max(min(globalshade+spr->Shade+6,numpalookups-1),0);
			asm3 = (int)(palookup[spr->Palette])+(globalshade<<8);
			globvis = globalhisibility;
			if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));
			globalpolytype = ((spr->CStat&2)>>1)+1;

				//relative alignment stuff
			ox = x2-x1; oy = y2-y1;
			i = ox*ox+oy*oy; if (i == 0) continue; i = (65536*16384)/i;
			globalx1 = mulscale10(dmulscale10(ox,bakgxvect,oy,bakgyvect),i);
			globaly1 = mulscale10(dmulscale10(ox,bakgyvect,-oy,bakgxvect),i);
			ox = y1-y4; oy = x4-x1;
			i = ox*ox+oy*oy; if (i == 0) continue; i = (65536*16384)/i;
			globalx2 = mulscale10(dmulscale10(ox,bakgxvect,oy,bakgyvect),i);
			globaly2 = mulscale10(dmulscale10(ox,bakgyvect,-oy,bakgxvect),i);

			ox = picsiz[globalpicnum]; oy = ((ox>>4)&15); ox &= 15;
			if (pow2long[ox] != xspan)
			{
				ox++;
				globalx1 = mulscale(globalx1,xspan,ox);
				globaly1 = mulscale(globaly1,xspan,ox);
			}

			bakx1 = (bakx1>>4)-(xdim<<7); baky1 = (baky1>>4)-(ydim<<7);
			globalposx = dmulscale28(-baky1,globalx1,-bakx1,globaly1);
			globalposy = dmulscale28(bakx1,globalx2,-baky1,globaly2);

			if ((spr->CStat&2) == 0)
				msethlineshift(ox,oy);
			else
				tsethlineshift(ox,oy);

			if ((spr->CStat&0x4) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalposx = -globalposx;
			asm1 = (globaly1<<2); globalx1 <<= 2; globalposx <<= (20+2);
			asm2 = (globalx2<<2); globaly2 <<= 2; globalposy <<= (20+2);

			fillpolygon(npoints);
		}
	}
}


int inside (long x, long y, short sectnum)
{
	XBUILD_MAP_WALL *wal;
	long i, x1, y1, x2, y2;
	unsigned long cnt;

	if ((sectnum < 0) || (sectnum >= SOFT_Map.Mapinfo.SectorNumber)) return(-1);

	cnt = 0;
	wal = &SOFT_Map.Wall[SOFT_Map.Sector[sectnum].WallPointer];
	i = SOFT_Map.Sector[sectnum].WallNumber;
	do
	{
		y1 = wal->Y-y; y2 = SOFT_Map.Wall[wal->Point2].Y-y;
		if ((y1^y2) < 0)
		{
			x1 = wal->X-x; x2 = SOFT_Map.Wall[wal->Point2].X-x;
			if ((x1^x2) >= 0) cnt ^= x1; else cnt ^= (x1*y2-x2*y1)^y2;
		}
		wal++; i--;
	} while (i);
	return(cnt>>31);
}

void updatesector(long x, long y, short *sectnum)
{
	XBUILD_MAP_WALL *wal;
	long i, j;

	if (inside(x,y,*sectnum) == 1) return;

	if ((*sectnum >= 0) && (*sectnum < SOFT_Map.Mapinfo.SectorNumber))
	{
		wal = &SOFT_Map.Wall[SOFT_Map.Sector[*sectnum].WallPointer];
		j = SOFT_Map.Sector[*sectnum].WallNumber;
		do
		{
			i = wal->NextSector;
			if (i >= 0)
				if (inside(x,y,(short)i) == 1)
				{
					*sectnum = i;
					return;
				}
			wal++;
			j--;
		} while (j != 0);
	}

	for(i=SOFT_Map.Mapinfo.SectorNumber-1;i>=0;i--)
		if (inside(x,y,(short)i) == 1)
		{
			*sectnum = i;
			return;
		}

	*sectnum = -1;
}

void getzsofslope(short sectnum, long dax, long day, long *ceilz, long *florz)
{
	long dx, dy, i, j;
	XBUILD_MAP_WALL *wal, *wal2;
	XBUILD_MAP_SECTOR *sec;

	sec = &SOFT_Map.Sector[sectnum];
	*ceilz = sec->CZ; *florz = sec->FZ;
	if ((sec->CStat|sec->FStat)&2)
	{
		wal = &SOFT_Map.Wall[sec->WallPointer]; wal2 = &SOFT_Map.Wall[wal->Point2];
		dx = wal2->X-wal->X; dy = wal2->Y-wal->Y;
		i = (nsqrtasm(dx*dx+dy*dy)<<5); if (i == 0) return;
		j = dmulscale3(dx,day-wal->Y,-dy,dax-wal->X);
		if (sec->CStat&2) *ceilz = (*ceilz)+scale(sec->CHei,j,i);
		if (sec->FStat&2) *florz = (*florz)+scale(sec->FHei,j,i);
	}
}

void scansector(short sectnum)
{
	XBUILD_MAP_WALL *wal, *wal2;
	XBUILD_MAP_SPRITE *spr;
	long i, xs, ys, xp, yp, x1, y1, x2, y2, xp1, yp1, xp2, yp2, templong;
	short z, zz, startwall, endwall, numscansbefore, scanfirst, bunchfrst;
	short nextsectnum;

	if (sectnum < 0) return;

	//if (automapping) show2dsector[sectnum>>3] |= pow2char[sectnum&7];

	sectorborder[0] = sectnum, sectorbordercnt = 1;
	do
	{
		sectnum = sectorborder[--sectorbordercnt];

		for(z=headspritesect[sectnum];z>=0;z=nextspritesect[z])
		{
			spr = &SOFT_Map.Sprite[z];
			if ((((spr->CStat&0x8000) == 0) || (showinvisibility)) &&
				  (spr->RepX > 0) && (spr->RepY > 0) &&
				  (spritesortcnt < MAXSPRITESONSCREEN))
			{
				xs = spr->X-globalposx; ys = spr->Y-globalposy;
				if ((spr->CStat&48) || (xs*cosglobalang+ys*singlobalang > 0))
				{
					//copybufbyte(spr,&tsprite[spritesortcnt],sizeof(spritetype));
					memcpy(spr, &tsprite[spritesortcnt], sizeof(XBUILD_MAP_SPRITE));
					tsprite[spritesortcnt++].Owner = z;
				}
			}
		}

		gotsector[sectnum>>3] |= pow2char[sectnum&7];

		bunchfrst = numbunches;
		numscansbefore = numscans;

		startwall = SOFT_Map.Sector[sectnum].WallPointer;
		endwall = startwall + SOFT_Map.Sector[sectnum].WallNumber;
		scanfirst = numscans;
		for(z=startwall,wal=&SOFT_Map.Wall[z];z<endwall;z++,wal++)
		{
			nextsectnum = wal->NextSector;

			wal2 = &SOFT_Map.Wall[wal->Point2];
			x1 = wal->X-globalposx; y1 = wal->Y-globalposy;
			x2 = wal2->X-globalposx; y2 = wal2->Y-globalposy;

			if ((nextsectnum >= 0) && ((wal->CStat&32) == 0))
				if ((gotsector[nextsectnum>>3]&pow2char[nextsectnum&7]) == 0)
				{
					templong = x1*y2-x2*y1;
					if (((unsigned)templong+262144) < 524288)
						if (mulscale5(templong,templong) <= (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
							sectorborder[sectorbordercnt++] = nextsectnum;
				}

			if ((z == startwall) || (SOFT_Map.Wall[z-1].Point2 != z))
			{
				xp1 = dmulscale6(y1,cosglobalang,-x1,singlobalang);
				yp1 = dmulscale6(x1,cosviewingrangeglobalang,y1,sinviewingrangeglobalang);
			}
			else
			{
				xp1 = xp2;
				yp1 = yp2;
			}
			xp2 = dmulscale6(y2,cosglobalang,-x2,singlobalang);
			yp2 = dmulscale6(x2,cosviewingrangeglobalang,y2,sinviewingrangeglobalang);
			if ((yp1 < 256) && (yp2 < 256)) goto skipitaddwall;

				//If wall's NOT facing you
			if (dmulscale32(xp1,yp2,-xp2,yp1) >= 0) goto skipitaddwall;

			if (xp1 >= -yp1)
			{
				if ((xp1 > yp1) || (yp1 == 0)) goto skipitaddwall;
				xb1[numscans] = halfxdimen + scale(xp1,halfxdimen,yp1);
				if (xp1 >= 0) xb1[numscans]++;   //Fix for SIGNED divide
				if (xb1[numscans] >= xdimen) xb1[numscans] = xdimen-1;
				yb1[numscans] = yp1;
			}
			else
			{
				if (xp2 < -yp2) goto skipitaddwall;
				xb1[numscans] = 0;
				templong = yp1-yp2+xp1-xp2;
				if (templong == 0) goto skipitaddwall;
				yb1[numscans] = yp1 + scale(yp2-yp1,xp1+yp1,templong);
			}
			if (yb1[numscans] < 256) goto skipitaddwall;

			if (xp2 <= yp2)
			{
				if ((xp2 < -yp2) || (yp2 == 0)) goto skipitaddwall;
				xb2[numscans] = halfxdimen + scale(xp2,halfxdimen,yp2) - 1;
				if (xp2 >= 0) xb2[numscans]++;   //Fix for SIGNED divide
				if (xb2[numscans] >= xdimen) xb2[numscans] = xdimen-1;
				yb2[numscans] = yp2;
			}
			else
			{
				if (xp1 > yp1) goto skipitaddwall;
				xb2[numscans] = xdimen-1;
				templong = xp2-xp1+yp1-yp2;
				if (templong == 0) goto skipitaddwall;
				yb2[numscans] = yp1 + scale(yp2-yp1,yp1-xp1,templong);
			}
			if ((yb2[numscans] < 256) || (xb1[numscans] > xb2[numscans])) goto skipitaddwall;

				//Made it all the way!
			thesector[numscans] = sectnum; thewall[numscans] = z;
			rx1[numscans] = xp1; ry1[numscans] = yp1;
			rx2[numscans] = xp2; ry2[numscans] = yp2;
			p2[numscans] = numscans+1;
			numscans++;
skipitaddwall:

			if ((SOFT_Map.Wall[z].Point2 < z) && (scanfirst < numscans))
				p2[numscans-1] = scanfirst, scanfirst = numscans;
		}

		for(z=numscansbefore;z<numscans;z++)
			if ((SOFT_Map.Wall[thewall[z]].Point2 != thewall[p2[z]]) || (xb2[z] >= xb1[p2[z]]))
				bunchfirst[numbunches++] = p2[z], p2[z] = -1;

		for(z=bunchfrst;z<numbunches;z++)
		{
			for(zz=bunchfirst[z];p2[zz]>=0;zz=p2[zz]);
			bunchlast[z] = zz;
		}
	} while (sectorbordercnt > 0);
}

int wallfront (long l1, long l2)
{
	XBUILD_MAP_WALL *wal;
	long x11, y11, x21, y21, x12, y12, x22, y22, dx, dy, t1, t2;

	wal = &SOFT_Map.Wall[thewall[l1]]; x11 = wal->X; y11 = wal->Y;
	wal = &SOFT_Map.Wall[wal->Point2]; x21 = wal->X; y21 = wal->Y;
	wal = &SOFT_Map.Wall[thewall[l2]]; x12 = wal->X; y12 = wal->Y;
	wal = &SOFT_Map.Wall[wal->Point2]; x22 = wal->X; y22 = wal->Y;

	dx = x21-x11; dy = y21-y11;
	t1 = dmulscale2(x12-x11,dy,-dx,y12-y11); //p1(l2) vs. l1
	t2 = dmulscale2(x22-x11,dy,-dx,y22-y11); //p2(l2) vs. l1
	if (t1 == 0) { t1 = t2; if (t1 == 0) return(-1); }
	if (t2 == 0) t2 = t1;
	if ((t1^t2) >= 0)
	{
		t2 = dmulscale2(globalposx-x11,dy,-dx,globalposy-y11); //pos vs. l1
		return((t2^t1) >= 0);
	}

	dx = x22-x12; dy = y22-y12;
	t1 = dmulscale2(x11-x12,dy,-dx,y11-y12); //p1(l1) vs. l2
	t2 = dmulscale2(x21-x12,dy,-dx,y21-y12); //p2(l1) vs. l2
	if (t1 == 0) { t1 = t2; if (t1 == 0) return(-1); }
	if (t2 == 0) t2 = t1;
	if ((t1^t2) >= 0)
	{
		t2 = dmulscale2(globalposx-x12,dy,-dx,globalposy-y12); //pos vs. l2
		return((t2^t1) < 0);
	}
	return(-2);
}

int bunchfront (long b1, long b2)
{
	long x1b1, x2b1, x1b2, x2b2, b1f, b2f, i;

	b1f = bunchfirst[b1]; x1b1 = xb1[b1f]; x2b2 = xb2[bunchlast[b2]]+1;
	if (x1b1 >= x2b2) return(-1);
	b2f = bunchfirst[b2]; x1b2 = xb1[b2f]; x2b1 = xb2[bunchlast[b1]]+1;
	if (x1b2 >= x2b1) return(-1);

	if (x1b1 >= x1b2)
	{
		for(i=b2f;xb2[i]<x1b1;i=p2[i]);
		return(wallfront(b1f,i));
	}
	for(i=b1f;xb2[i]<x1b2;i=p2[i]);
	return(wallfront(i,b2f));
}

int owallmost(short *mostbuf, long w, long z)
{
	long bad, x, intx, inty, xcross, y, yy, yinc;
	long s1, s2, s3, s4, ix1, ix2, iy1, iy2, t, x1, x2;

	z <<= 7;
	s1 = mulscale20(globaluclip,yb1[w]); s2 = mulscale20(globaluclip,yb2[w]);
	s3 = mulscale20(globaldclip,yb1[w]); s4 = mulscale20(globaldclip,yb2[w]);
	bad = (z<s1)+((z<s2)<<1)+((z>s3)<<2)+((z>s4)<<3);

	ix1 = xb1[w]; iy1 = yb1[w];
	ix2 = xb2[w]; iy2 = yb2[w];

	if ((bad&3) == 3)
	{
		memset(&mostbuf[ix1], 0, (ix2-ix1+1)*sizeof(mostbuf[0]));
		//clearbufbyte(&mostbuf[ix1],(ix2-ix1+1)*sizeof(mostbuf[0]),0L);
		return(bad);
	}

	if ((bad&12) == 12)
	{
		memset(&mostbuf[ix1], ydimen+(ydimen<<16), (ix2-ix1+1)*sizeof(mostbuf[0]));
		//clearbufbyte(&mostbuf[ix1],(ix2-ix1+1)*sizeof(mostbuf[0]),ydimen+(ydimen<<16));
		return(bad);
	}

	if (bad&3)
	{
		t = divscale30(z-s1,s2-s1);
		inty = yb1[w] + mulscale30(yb2[w]-yb1[w],t);
		xcross = xb1[w] + scale(mulscale30(yb2[w],t),xb2[w]-xb1[w],inty);

		if ((bad&3) == 2)
		{
			if (xb1[w] <= xcross) { iy2 = inty; ix2 = xcross; }
			memset(&mostbuf[xcross+1], 0, (xb2[w]-xcross)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xcross+1],(xb2[w]-xcross)*sizeof(mostbuf[0]),0L);
		}
		else
		{
			if (xcross <= xb2[w]) { iy1 = inty; ix1 = xcross; }
			memset(&mostbuf[xb1[w]], 0, (xcross-xb1[w]+1)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xb1[w]],(xcross-xb1[w]+1)*sizeof(mostbuf[0]),0L);
		}
	}

	if (bad&12)
	{
		t = divscale30(z-s3,s4-s3);
		inty = yb1[w] + mulscale30(yb2[w]-yb1[w],t);
		xcross = xb1[w] + scale(mulscale30(yb2[w],t),xb2[w]-xb1[w],inty);

		if ((bad&12) == 8)
		{
			if (xb1[w] <= xcross) { iy2 = inty; ix2 = xcross; }
			memset(&mostbuf[xcross+1], ydimen+(ydimen<<16), (xb2[w]-xcross)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xcross+1],(xb2[w]-xcross)*sizeof(mostbuf[0]),ydimen+(ydimen<<16));
		}
		else
		{
			if (xcross <= xb2[w]) { iy1 = inty; ix1 = xcross; }
			memset(&mostbuf[xb1[w]], ydimen+(ydimen<<16), (xcross-xb1[w]+1)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xb1[w]],(xcross-xb1[w]+1)*sizeof(mostbuf[0]),ydimen+(ydimen<<16));
		}
	}

	y = (scale(z,xdimenscale,iy1)<<4);
	yinc = ((scale(z,xdimenscale,iy2)<<4)-y) / (ix2-ix1+1);
	qinterpolatedown16short((int)&mostbuf[ix1],ix2-ix1+1,y+(globalhoriz<<16),yinc);

	if (mostbuf[ix1] < 0) mostbuf[ix1] = 0;
	if (mostbuf[ix1] > ydimen) mostbuf[ix1] = ydimen;
	if (mostbuf[ix2] < 0) mostbuf[ix2] = 0;
	if (mostbuf[ix2] > ydimen) mostbuf[ix2] = ydimen;

	return(bad);
}

int wallmost(short *mostbuf, long w, long sectnum, char dastat)
{
	long bad, i, j, t, x, y, z, intx, inty, intz, xcross, yinc, fw;
	long x1, y1, z1, x2, y2, z2, xv, yv, dx, dy, dasqr, oz1, oz2;
	long s1, s2, s3, s4, ix1, ix2, iy1, iy2;
	char datempbuf[256];

	if (dastat == 0)
	{
		z = SOFT_Map.Sector[sectnum].CZ-globalposz;
		if ((SOFT_Map.Sector[sectnum].CStat&2) == 0) return(owallmost(mostbuf,w,z));
	}
	else
	{
		z = SOFT_Map.Sector[sectnum].FZ-globalposz;
		if ((SOFT_Map.Sector[sectnum].FStat&2) == 0) return(owallmost(mostbuf,w,z));
	}

	i = thewall[w];
	if (i == SOFT_Map.Sector[sectnum].WallPointer) return(owallmost(mostbuf,w,z));

	x1 = SOFT_Map.Wall[i].X; x2 = SOFT_Map.Wall[SOFT_Map.Wall[i].Point2].X-x1;
	y1 = SOFT_Map.Wall[i].Y; y2 = SOFT_Map.Wall[SOFT_Map.Wall[i].Point2].Y-y1;

	fw = SOFT_Map.Sector[sectnum].WallPointer; i = SOFT_Map.Wall[fw].Point2;
	dx = SOFT_Map.Wall[i].X-SOFT_Map.Wall[fw].X; dy = SOFT_Map.Wall[i].Y-SOFT_Map.Wall[fw].Y;
	dasqr = krecipasm(nsqrtasm(dx*dx+dy*dy));

	if (xb1[w] == 0)
		{ xv = cosglobalang+sinviewingrangeglobalang; yv = singlobalang-cosviewingrangeglobalang; }
	else
		{ xv = x1-globalposx; yv = y1-globalposy; }
	i = xv*(y1-globalposy)-yv*(x1-globalposx); j = yv*x2-xv*y2;
	if (klabs(j) > klabs(i>>3)) i = divscale28(i,j);
	if (dastat == 0)
	{
		t = mulscale15(SOFT_Map.Sector[sectnum].CHei,dasqr);
		z1 = SOFT_Map.Sector[sectnum].CZ;
	}
	else
	{
		t = mulscale15(SOFT_Map.Sector[sectnum].FHei,dasqr);
		z1 = SOFT_Map.Sector[sectnum].FZ;
	}
	z1 = dmulscale24(dx*t,mulscale20(y2,i)+((y1-SOFT_Map.Wall[fw].Y)<<8),
						 -dy*t,mulscale20(x2,i)+((x1-SOFT_Map.Wall[fw].X)<<8))+((z1-globalposz)<<7);


	if (xb2[w] == xdimen-1)
		{ xv = cosglobalang-sinviewingrangeglobalang; yv = singlobalang+cosviewingrangeglobalang; }
	else
		{ xv = (x2+x1)-globalposx; yv = (y2+y1)-globalposy; }
	i = xv*(y1-globalposy)-yv*(x1-globalposx); j = yv*x2-xv*y2;
	if (klabs(j) > klabs(i>>3)) i = divscale28(i,j);
	if (dastat == 0)
	{
		t = mulscale15(SOFT_Map.Sector[sectnum].CHei,dasqr);
		z2 = SOFT_Map.Sector[sectnum].CZ;
	}
	else
	{
		t = mulscale15(SOFT_Map.Sector[sectnum].FHei,dasqr);
		z2 = SOFT_Map.Sector[sectnum].FZ;
	}
	z2 = dmulscale24(dx*t,mulscale20(y2,i)+((y1-SOFT_Map.Wall[fw].Y)<<8),
						 -dy*t,mulscale20(x2,i)+((x1-SOFT_Map.Wall[fw].X)<<8))+((z2-globalposz)<<7);


	s1 = mulscale20(globaluclip,yb1[w]); s2 = mulscale20(globaluclip,yb2[w]);
	s3 = mulscale20(globaldclip,yb1[w]); s4 = mulscale20(globaldclip,yb2[w]);
	bad = (z1<s1)+((z2<s2)<<1)+((z1>s3)<<2)+((z2>s4)<<3);

	ix1 = xb1[w]; ix2 = xb2[w];
	iy1 = yb1[w]; iy2 = yb2[w];
	oz1 = z1; oz2 = z2;

	if ((bad&3) == 3)
	{
		memset(&mostbuf[ix1], 0, (ix2-ix1+1)*sizeof(mostbuf[0]));
		//clearbufbyte(&mostbuf[ix1],(ix2-ix1+1)*sizeof(mostbuf[0]),0L);
		return(bad);
	}

	if ((bad&12) == 12)
	{
		memset(&mostbuf[ix1], ydimen+(ydimen<<16), (ix2-ix1+1)*sizeof(mostbuf[0]));
		//clearbufbyte(&mostbuf[ix1],(ix2-ix1+1)*sizeof(mostbuf[0]),ydimen+(ydimen<<16));
		return(bad);
	}

	if (bad&3)
	{
			//inty = intz / (globaluclip>>16)
		t = divscale30(oz1-s1,s2-s1+oz1-oz2);
		inty = yb1[w] + mulscale30(yb2[w]-yb1[w],t);
		intz = oz1 + mulscale30(oz2-oz1,t);
		xcross = xb1[w] + scale(mulscale30(yb2[w],t),xb2[w]-xb1[w],inty);

		//t = divscale30((x1<<4)-xcross*yb1[w],xcross*(yb2[w]-yb1[w])-((x2-x1)<<4));
		//inty = yb1[w] + mulscale30(yb2[w]-yb1[w],t);
		//intz = z1 + mulscale30(z2-z1,t);

		if ((bad&3) == 2)
		{
			if (xb1[w] <= xcross) { z2 = intz; iy2 = inty; ix2 = xcross; }
			memset(&mostbuf[xcross+1], 0, (xb2[w]-xcross)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xcross+1],(xb2[w]-xcross)*sizeof(mostbuf[0]),0L);
		}
		else
		{
			if (xcross <= xb2[w]) { z1 = intz; iy1 = inty; ix1 = xcross; }
			memset(&mostbuf[xb1[w]], 0, (xcross-xb1[w]+1)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xb1[w]],(xcross-xb1[w]+1)*sizeof(mostbuf[0]),0L);
		}
	}

	if (bad&12)
	{
			//inty = intz / (globaldclip>>16)
		t = divscale30(oz1-s3,s4-s3+oz1-oz2);
		inty = yb1[w] + mulscale30(yb2[w]-yb1[w],t);
		intz = oz1 + mulscale30(oz2-oz1,t);
		xcross = xb1[w] + scale(mulscale30(yb2[w],t),xb2[w]-xb1[w],inty);

		//t = divscale30((x1<<4)-xcross*yb1[w],xcross*(yb2[w]-yb1[w])-((x2-x1)<<4));
		//inty = yb1[w] + mulscale30(yb2[w]-yb1[w],t);
		//intz = z1 + mulscale30(z2-z1,t);

		if ((bad&12) == 8)
		{
			if (xb1[w] <= xcross) { z2 = intz; iy2 = inty; ix2 = xcross; }
			memset(&mostbuf[xcross+1], ydimen+(ydimen<<16), (xb2[w]-xcross)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xcross+1],(xb2[w]-xcross)*sizeof(mostbuf[0]),ydimen+(ydimen<<16));
		}
		else
		{
			if (xcross <= xb2[w]) { z1 = intz; iy1 = inty; ix1 = xcross; }
			memset(&mostbuf[xb1[w]], ydimen+(ydimen<<16), (xcross-xb1[w]+1)*sizeof(mostbuf[0]));
			//clearbufbyte(&mostbuf[xb1[w]],(xcross-xb1[w]+1)*sizeof(mostbuf[0]),ydimen+(ydimen<<16));
		}
	}

	y = (scale(z1,xdimenscale,iy1)<<4);
	yinc = ((scale(z2,xdimenscale,iy2)<<4)-y) / (ix2-ix1+1);
	qinterpolatedown16short((long)&mostbuf[ix1],ix2-ix1+1,y+(globalhoriz<<16),yinc);

	if (mostbuf[ix1] < 0) mostbuf[ix1] = 0;
	if (mostbuf[ix1] > ydimen) mostbuf[ix1] = ydimen;
	if (mostbuf[ix2] < 0) mostbuf[ix2] = 0;
	if (mostbuf[ix2] > ydimen) mostbuf[ix2] = ydimen;

	return(bad);
}

int getpalookup(long davis, long dashade)
{
	return(min(max(dashade+(davis>>8),0),numpalookups-1));
}

void hline (long xr, long yp)
{
	long xl, r, s;

	xl = lastx[yp]; if (xl > xr) return;
	r = horizlookup2[yp-globalhoriz+horizycent];
	asm1 = globalx1*r;
	asm2 = globaly2*r;
	s = ((long)getpalookup((long)mulscale16(r,globvis),globalshade)<<8);

	hlineasm4(xr-xl,0L,s,globalx2*r+globalypanning,globaly1*r+globalxpanning,
		ylookup[yp]+xr+frameoffset);
}

void slowhline (long xr, long yp)
{
	long xl, x, y, ox, oy, r, p, shade;

	xl = lastx[yp]; if (xl > xr) return;
	r = horizlookup2[yp-globalhoriz+horizycent];
	asm1 = globalx1*r;
	asm2 = globaly2*r;

	asm3 = (long)globalpalwritten + ((long)getpalookup((long)mulscale16(r,globvis),globalshade)<<8);
	if (!(globalorientation&256))
	{
		mhline(globalbufplc,globaly1*r+globalxpanning-asm1*(xr-xl),(xr-xl)<<16,0L,
			globalx2*r+globalypanning-asm2*(xr-xl),ylookup[yp]+xl+frameoffset);
		return;
	}
	thline(globalbufplc,globaly1*r+globalxpanning-asm1*(xr-xl),(xr-xl)<<16,0L,
		globalx2*r+globalypanning-asm2*(xr-xl),ylookup[yp]+xl+frameoffset);
	transarea += (xr-xl);
}

void florscan (long x1, long x2, long sectnum)
{
	long i, j, ox, oy, x, y1, y2, twall, bwall;
	XBUILD_MAP_SECTOR *sec;

	sec = &SOFT_Map.Sector[sectnum];
	if (palookup[sec->FPal] != globalpalwritten)
	{
		globalpalwritten = palookup[sec->FPal];
		setpalookupaddress((int)globalpalwritten);
	}

	globalzd = globalposz-sec->FZ;
	if (globalzd > 0) return;
	globalpicnum = sec->FPic;
	if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
	if(SOFT_Tiles[globalpicnum] == NULL)
	{
		SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
		XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
		picsiz[globalpicnum] = ((char)j);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
		picsiz[globalpicnum] += ((char)(j<<4));
	}
	//setgotpic(globalpicnum);
	if ((SOFT_Tiles[globalpicnum]->Width <= 0) || (SOFT_Tiles[globalpicnum]->Height <= 0)) return;
	//if (picanm[globalpicnum]&192) globalpicnum += animateoffs((short)globalpicnum,(short)sectnum);

	//if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
	globalbufplc = (long)SOFT_Tiles[globalpicnum]->lpData;

	globalshade = (long)sec->FShade;
	globvis = globalcisibility;
	if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));
	globalorientation = (long)sec->FStat;


	if ((globalorientation&64) == 0)
	{
		globalx1 = singlobalang; globalx2 = singlobalang;
		globaly1 = cosglobalang; globaly2 = cosglobalang;
		globalxpanning = (globalposx<<20);
		globalypanning = -(globalposy<<20);
	}
	else
	{
		j = sec->WallPointer;
		ox = SOFT_Map.Wall[SOFT_Map.Wall[j].Point2].X - SOFT_Map.Wall[j].X;
		oy = SOFT_Map.Wall[SOFT_Map.Wall[j].Point2].Y - SOFT_Map.Wall[j].Y;
		i = nsqrtasm(ox*ox+oy*oy); if (i == 0) i = 1024; else i = 1048576/i;
		globalx1 = mulscale10(dmulscale10(ox,singlobalang,-oy,cosglobalang),i);
		globaly1 = mulscale10(dmulscale10(ox,cosglobalang,oy,singlobalang),i);
		globalx2 = -globalx1;
		globaly2 = -globaly1;

		ox = ((SOFT_Map.Wall[j].X-globalposx)<<6); oy = ((SOFT_Map.Wall[j].Y-globalposy)<<6);
		i = dmulscale14(oy,cosglobalang,-ox,singlobalang);
		j = dmulscale14(ox,cosglobalang,oy,singlobalang);
		ox = i; oy = j;
		globalxpanning = globalx1*ox - globaly1*oy;
		globalypanning = globaly2*ox + globalx2*oy;
	}
	globalx2 = mulscale16(globalx2,viewingrangerecip);
	globaly1 = mulscale16(globaly1,viewingrangerecip);
	globalxshift = (8-(picsiz[globalpicnum]&15));
	globalyshift = (8-(picsiz[globalpicnum]>>4));
	if (globalorientation&8) { globalxshift++; globalyshift++; }

	if ((globalorientation&0x4) > 0)
	{
		i = globalxpanning; globalxpanning = globalypanning; globalypanning = i;
		i = globalx2; globalx2 = -globaly1; globaly1 = -i;
		i = globalx1; globalx1 = globaly2; globaly2 = i;
	}
	if ((globalorientation&0x10) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalxpanning = -globalxpanning;
	if ((globalorientation&0x20) > 0) globalx2 = -globalx2, globaly2 = -globaly2, globalypanning = -globalypanning;
	globalx1 <<= globalxshift; globaly1 <<= globalxshift;
	globalx2 <<= globalyshift;  globaly2 <<= globalyshift;
	globalxpanning <<= globalxshift; globalypanning <<= globalyshift;
	globalxpanning += (((long)sec->FPanX)<<24);
	globalypanning += (((long)sec->FPanY)<<24);
	globaly1 = (-globalx1-globaly1)*halfxdimen;
	globalx2 = (globalx2-globaly2)*halfxdimen;

	sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4,globalbufplc);

	globalx2 += globaly2*(x1-1);
	globaly1 += globalx1*(x1-1);
	globalx1 = mulscale16(globalx1,globalzd);
	globalx2 = mulscale16(globalx2,globalzd);
	globaly1 = mulscale16(globaly1,globalzd);
	globaly2 = mulscale16(globaly2,globalzd);
	globvis = klabs(mulscale10(globvis,globalzd));

	if (!(globalorientation&0x180))
	{
		y1 = max(dplc[x1],umost[x1]); y2 = y1;
		for(x=x1;x<=x2;x++)
		{
			twall = max(dplc[x],umost[x])-1; bwall = dmost[x];
			if (twall < bwall-1)
			{
				if (twall >= y2)
				{
					while (y1 < y2-1) hline(x-1,++y1);
					y1 = twall;
				}
				else
				{
					while (y1 < twall) hline(x-1,++y1);
					while (y1 > twall) lastx[y1--] = x;
				}
				while (y2 > bwall) hline(x-1,--y2);
				while (y2 < bwall) lastx[y2++] = x;
			}
			else
			{
				while (y1 < y2-1) hline(x-1,++y1);
				if (x == x2) { globalx2 += globaly2; globaly1 += globalx1; break; }
				y1 = max(dplc[x+1],umost[x+1]); y2 = y1;
			}
			globalx2 += globaly2; globaly1 += globalx1;
		}
		while (y1 < y2-1) hline(x2,++y1);
		return;
	}

	switch(globalorientation&0x180)
	{
		case 128:
			msethlineshift(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);
			break;
		case 256:
			//settransnormal();
			tsethlineshift(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);
			break;
		case 384:
			//settransreverse();
			tsethlineshift(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);
			break;
	}

	y1 = max(dplc[x1],umost[x1]); y2 = y1;
	for(x=x1;x<=x2;x++)
	{
		twall = max(dplc[x],umost[x])-1; bwall = dmost[x];
		if (twall < bwall-1)
		{
			if (twall >= y2)
			{
				while (y1 < y2-1) slowhline(x-1,++y1);
				y1 = twall;
			}
			else
			{
				while (y1 < twall) slowhline(x-1,++y1);
				while (y1 > twall) lastx[y1--] = x;
			}
			while (y2 > bwall) slowhline(x-1,--y2);
			while (y2 < bwall) lastx[y2++] = x;
		}
		else
		{
			while (y1 < y2-1) slowhline(x-1,++y1);
			if (x == x2) { globalx2 += globaly2; globaly1 += globalx1; break; }
			y1 = max(dplc[x+1],umost[x+1]); y2 = y1;
		}
		globalx2 += globaly2; globaly1 += globalx1;
	}
	while (y1 < y2-1) slowhline(x2,++y1);
}

void ceilscan (long x1, long x2, long sectnum)
{
	long i, j, ox, oy, x, y1, y2, twall, bwall;
	XBUILD_MAP_SECTOR *sec;

	sec = &SOFT_Map.Sector[sectnum];
	if (palookup[sec->CPal] != globalpalwritten)
	{
		globalpalwritten = palookup[sec->CPal];
		setpalookupaddress((int)globalpalwritten);
	}

	globalzd = sec->CZ-globalposz;
	if (globalzd > 0) return;
	//GRAB PICTURE HERE!!!!!
	globalpicnum = sec->CPic;
	if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
	if(SOFT_Tiles[globalpicnum] == NULL)
	{
		SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
		XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
		picsiz[globalpicnum] = ((char)j);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
		picsiz[globalpicnum] += ((char)(j<<4));
	}
	//setgotpic(globalpicnum);
	if ((SOFT_Tiles[globalpicnum]->Width <= 0) || (SOFT_Tiles[globalpicnum]->Height <= 0)) return;
	//ANIMATION SYSTEM
	//if (picanm[globalpicnum]&192) globalpicnum += animateoffs((short)globalpicnum,(short)sectnum);

	//if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
	globalbufplc = (long)SOFT_Tiles[globalpicnum]->lpData;

	globalshade = (long)sec->CShade;
	globvis = globalcisibility;
	if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));
	globalorientation = (long)sec->CStat;


	if ((globalorientation&64) == 0)
	{
		globalx1 = singlobalang; globalx2 = singlobalang;
		globaly1 = cosglobalang; globaly2 = cosglobalang;
		globalxpanning = (globalposx<<20);
		globalypanning = -(globalposy<<20);
	}
	else
	{
		j = sec->WallPointer;
		ox = SOFT_Map.Wall[SOFT_Map.Wall[j].Point2].X - SOFT_Map.Wall[j].X;
		oy = SOFT_Map.Wall[SOFT_Map.Wall[j].Point2].Y - SOFT_Map.Wall[j].Y;
		i = nsqrtasm(ox*ox+oy*oy); if (i == 0) i = 1024; else i = 1048576/i;
		globalx1 = mulscale10(dmulscale10(ox,singlobalang,-oy,cosglobalang),i);
		globaly1 = mulscale10(dmulscale10(ox,cosglobalang,oy,singlobalang),i);
		globalx2 = -globalx1;
		globaly2 = -globaly1;

		ox = ((SOFT_Map.Wall[j].X-globalposx)<<6); oy = ((SOFT_Map.Wall[j].Y-globalposy)<<6);
		i = dmulscale14(oy,cosglobalang,-ox,singlobalang);
		j = dmulscale14(ox,cosglobalang,oy,singlobalang);
		ox = i; oy = j;
		globalxpanning = globalx1*ox - globaly1*oy;
		globalypanning = globaly2*ox + globalx2*oy;
	}
	globalx2 = mulscale16(globalx2,viewingrangerecip);
	globaly1 = mulscale16(globaly1,viewingrangerecip);
	globalxshift = (8-(picsiz[globalpicnum]&15));
	globalyshift = (8-(picsiz[globalpicnum]>>4));
	if (globalorientation&8) { globalxshift++; globalyshift++; }

	if ((globalorientation&0x4) > 0)
	{
		i = globalxpanning; globalxpanning = globalypanning; globalypanning = i;
		i = globalx2; globalx2 = -globaly1; globaly1 = -i;
		i = globalx1; globalx1 = globaly2; globaly2 = i;
	}
	if ((globalorientation&0x10) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalxpanning = -globalxpanning;
	if ((globalorientation&0x20) > 0) globalx2 = -globalx2, globaly2 = -globaly2, globalypanning = -globalypanning;
	globalx1 <<= globalxshift; globaly1 <<= globalxshift;
	globalx2 <<= globalyshift;  globaly2 <<= globalyshift;
	globalxpanning <<= globalxshift; globalypanning <<= globalyshift;
	globalxpanning += (((long)sec->CPanX)<<24);
	globalypanning += (((long)sec->CPanY)<<24);
	globaly1 = (-globalx1-globaly1)*halfxdimen;
	globalx2 = (globalx2-globaly2)*halfxdimen;

	sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4,globalbufplc);

	globalx2 += globaly2*(x1-1);
	globaly1 += globalx1*(x1-1);
	globalx1 = mulscale16(globalx1,globalzd);
	globalx2 = mulscale16(globalx2,globalzd);
	globaly1 = mulscale16(globaly1,globalzd);
	globaly2 = mulscale16(globaly2,globalzd);
	globvis = klabs(mulscale10(globvis,globalzd));

	if (!(globalorientation&0x180))
	{
		y1 = umost[x1]; y2 = y1;
		for(x=x1;x<=x2;x++)
		{
			twall = umost[x]-1; bwall = min(uplc[x],dmost[x]);
			if (twall < bwall-1)
			{
				if (twall >= y2)
				{
					while (y1 < y2-1) hline(x-1,++y1);
					y1 = twall;
				}
				else
				{
					while (y1 < twall) hline(x-1,++y1);
					while (y1 > twall) lastx[y1--] = x;
				}
				while (y2 > bwall) hline(x-1,--y2);
				while (y2 < bwall) lastx[y2++] = x;
			}
			else
			{
				while (y1 < y2-1) hline(x-1,++y1);
				if (x == x2) { globalx2 += globaly2; globaly1 += globalx1; break; }
				y1 = umost[x+1]; y2 = y1;
			}
			globalx2 += globaly2; globaly1 += globalx1;
		}
		while (y1 < y2-1) hline(x2,++y1);
		return;
	}

	switch(globalorientation&0x180)
	{
		case 128:
			msethlineshift(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);
			break;
		case 256:
			//settransnormal();
			tsethlineshift(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);
			break;
		case 384:
			//settransreverse();
			tsethlineshift(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);
			break;
	}

	y1 = umost[x1]; y2 = y1;
	for(x=x1;x<=x2;x++)
	{
		twall = umost[x]-1; bwall = min(uplc[x],dmost[x]);
		if (twall < bwall-1)
		{
			if (twall >= y2)
			{
				while (y1 < y2-1) slowhline(x-1,++y1);
				y1 = twall;
			}
			else
			{
				while (y1 < twall) slowhline(x-1,++y1);
				while (y1 > twall) lastx[y1--] = x;
			}
			while (y2 > bwall) slowhline(x-1,--y2);
			while (y2 < bwall) lastx[y2++] = x;
		}
		else
		{
			while (y1 < y2-1) slowhline(x-1,++y1);
			if (x == x2) { globalx2 += globaly2; globaly1 += globalx1; break; }
			y1 = umost[x+1]; y2 = y1;
		}
		globalx2 += globaly2; globaly1 += globalx1;
	}
	while (y1 < y2-1) slowhline(x2,++y1);
}

void wallscan(long x1, long x2, short *uwal, short *dwal, long *swal, long *lwal)
{
	long i, j, x, xnice, ynice, fpalookup, shade;
	long y1ve[4], y2ve[4], u4, d4, dax, z, tsizx, tsizy;
	char bad;

	if(SOFT_Tiles[globalpicnum] == NULL)
	{
		SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
		XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
		picsiz[globalpicnum] = ((char)j);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
		picsiz[globalpicnum] += ((char)(j<<4));
	}
	tsizx = SOFT_Tiles[globalpicnum]->Width;
	tsizy = SOFT_Tiles[globalpicnum]->Height;
	//setgotpic(globalpicnum);
	if ((tsizx <= 0) || (tsizy <= 0)) return;
	if ((uwal[x1] > ydimen) && (uwal[x2] > ydimen)) return;
	if ((dwal[x1] < 0) && (dwal[x2] < 0)) return;

	//if (waloff[globalpicnum] == 0) loadtile(globalpicnum);

	xnice = (pow2long[picsiz[globalpicnum]&15] == tsizx);
	if (xnice) tsizx--;
	ynice = (pow2long[picsiz[globalpicnum]>>4] == tsizy);
	if (ynice) tsizy = (picsiz[globalpicnum]>>4);

	fpalookup = (long)palookup[globalpal];

	setupvlineasm(globalshiftval);

	x = x1;
	while ((umost[x] > dmost[x]) && (x <= x2)) x++;

	for(;(x<=x2)&&((x+frameoffset)&3);x++)
	{
		y1ve[0] = max(uwal[x],umost[x]);
		y2ve[0] = min(dwal[x],dmost[x]);
		if (y2ve[0] <= y1ve[0]) continue;

		palookupoffse[0] = fpalookup+(getpalookup((long)mulscale16(swal[x],globvis),globalshade)<<8);

		bufplce[0] = lwal[x] + globalxpanning;
		if (bufplce[0] >= tsizx) { if (xnice == 0) bufplce[0] %= tsizx; else bufplce[0] &= tsizx; }
		if (ynice == 0) bufplce[0] *= tsizy; else bufplce[0] <<= tsizy;

		vince[0] = swal[x]*globalyscale;
		vplce[0] = globalzd + vince[0]*(y1ve[0]-globalhoriz+1);

		vlineasm1(vince[0],palookupoffse[0],y2ve[0]-y1ve[0]-1,vplce[0],bufplce[0]+(long)SOFT_Tiles[globalpicnum]->lpData,x+frameoffset+ylookup[y1ve[0]]);
	}
	for(;x<=x2-3;x+=4)
	{
		bad = 0;
		for(z=3;z>=0;z--)
		{
			y1ve[z] = max(uwal[x+z],umost[x+z]);
			y2ve[z] = min(dwal[x+z],dmost[x+z])-1;
			if (y2ve[z] < y1ve[z]) { bad += pow2char[z]; continue; }

			i = lwal[x+z] + globalxpanning;
			if (i >= tsizx) { if (xnice == 0) i %= tsizx; else i &= tsizx; }
			if (ynice == 0) i *= tsizy; else i <<= tsizy;
			bufplce[z] = (long)SOFT_Tiles[globalpicnum]->lpData+i;

			vince[z] = swal[x+z]*globalyscale;
			vplce[z] = globalzd + vince[z]*(y1ve[z]-globalhoriz+1);
		}
		if (bad == 15) continue;

		palookupoffse[0] = fpalookup+(getpalookup((long)mulscale16(swal[x],globvis),globalshade)<<8);
		palookupoffse[3] = fpalookup+(getpalookup((long)mulscale16(swal[x+3],globvis),globalshade)<<8);

		if ((palookupoffse[0] == palookupoffse[3]) && ((bad&0x9) == 0))
		{
			palookupoffse[1] = palookupoffse[0];
			palookupoffse[2] = palookupoffse[0];
		}
		else
		{
			palookupoffse[1] = fpalookup+(getpalookup((long)mulscale16(swal[x+1],globvis),globalshade)<<8);
			palookupoffse[2] = fpalookup+(getpalookup((long)mulscale16(swal[x+2],globvis),globalshade)<<8);
		}

		u4 = max(max(y1ve[0],y1ve[1]),max(y1ve[2],y1ve[3]));
		d4 = min(min(y2ve[0],y2ve[1]),min(y2ve[2],y2ve[3]));

		if ((bad != 0) || (u4 >= d4))
		{
			if (!(bad&1)) prevlineasm1(vince[0],palookupoffse[0],y2ve[0]-y1ve[0],vplce[0],bufplce[0],ylookup[y1ve[0]]+x+frameoffset+0);
			if (!(bad&2)) prevlineasm1(vince[1],palookupoffse[1],y2ve[1]-y1ve[1],vplce[1],bufplce[1],ylookup[y1ve[1]]+x+frameoffset+1);
			if (!(bad&4)) prevlineasm1(vince[2],palookupoffse[2],y2ve[2]-y1ve[2],vplce[2],bufplce[2],ylookup[y1ve[2]]+x+frameoffset+2);
			if (!(bad&8)) prevlineasm1(vince[3],palookupoffse[3],y2ve[3]-y1ve[3],vplce[3],bufplce[3],ylookup[y1ve[3]]+x+frameoffset+3);
			continue;
		}

		if (u4 > y1ve[0]) vplce[0] = prevlineasm1(vince[0],palookupoffse[0],u4-y1ve[0]-1,vplce[0],bufplce[0],ylookup[y1ve[0]]+x+frameoffset+0);
		if (u4 > y1ve[1]) vplce[1] = prevlineasm1(vince[1],palookupoffse[1],u4-y1ve[1]-1,vplce[1],bufplce[1],ylookup[y1ve[1]]+x+frameoffset+1);
		if (u4 > y1ve[2]) vplce[2] = prevlineasm1(vince[2],palookupoffse[2],u4-y1ve[2]-1,vplce[2],bufplce[2],ylookup[y1ve[2]]+x+frameoffset+2);
		if (u4 > y1ve[3]) vplce[3] = prevlineasm1(vince[3],palookupoffse[3],u4-y1ve[3]-1,vplce[3],bufplce[3],ylookup[y1ve[3]]+x+frameoffset+3);

		if (d4 >= u4) vlineasm4(d4-u4+1,ylookup[u4]+x+frameoffset);

		i = x+frameoffset+ylookup[d4+1];
		if (y2ve[0] > d4) prevlineasm1(vince[0],palookupoffse[0],y2ve[0]-d4-1,vplce[0],bufplce[0],i+0);
		if (y2ve[1] > d4) prevlineasm1(vince[1],palookupoffse[1],y2ve[1]-d4-1,vplce[1],bufplce[1],i+1);
		if (y2ve[2] > d4) prevlineasm1(vince[2],palookupoffse[2],y2ve[2]-d4-1,vplce[2],bufplce[2],i+2);
		if (y2ve[3] > d4) prevlineasm1(vince[3],palookupoffse[3],y2ve[3]-d4-1,vplce[3],bufplce[3],i+3);
	}
	for(;x<=x2;x++)
	{
		y1ve[0] = max(uwal[x],umost[x]);
		y2ve[0] = min(dwal[x],dmost[x]);
		if (y2ve[0] <= y1ve[0]) continue;

		palookupoffse[0] = fpalookup+(getpalookup((long)mulscale16(swal[x],globvis),globalshade)<<8);

		bufplce[0] = lwal[x] + globalxpanning;
		if (bufplce[0] >= tsizx) { if (xnice == 0) bufplce[0] %= tsizx; else bufplce[0] &= tsizx; }
		if (ynice == 0) bufplce[0] *= tsizy; else bufplce[0] <<= tsizy;

		vince[0] = swal[x]*globalyscale;
		vplce[0] = globalzd + vince[0]*(y1ve[0]-globalhoriz+1);

		vlineasm1(vince[0],palookupoffse[0],y2ve[0]-y1ve[0]-1,vplce[0],bufplce[0]+(long)SOFT_Tiles[globalpicnum]->lpData,x+frameoffset+ylookup[y1ve[0]]);
	}
}

void parascan (long dax1, long dax2, long sectnum, char dastat, long bunch)
{
	XBUILD_MAP_SECTOR *sec;
	long i, j, k, l, m, n, x, y, z, wallnum, nextsectnum, globalhorizbak;
	short *topptr, *botptr;

	sectnum = thesector[bunchfirst[bunch]]; sec = &SOFT_Map.Sector[sectnum];

	globalhorizbak = globalhoriz;
	if (parallaxyscale != 65536)
		globalhoriz = mulscale16(globalhoriz-(ydimen>>1),parallaxyscale) + (ydimen>>1);
	globvis = globalpisibility;
	//globalorientation = 0L;
	if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));

	if (dastat == 0)
	{
		globalpal = sec->CPal;
		globalpicnum = sec->CPic;
		globalshade = (long)sec->CShade;
		globalxpanning = (long)sec->CPanX;
		globalypanning = (long)sec->CPanY;
		topptr = umost;
		botptr = uplc;
	}
	else
	{
		globalpal = sec->FPal;
		globalpicnum = sec->FPic;
		globalshade = (long)sec->FShade;
		globalxpanning = (long)sec->FPanX;
		globalypanning = (long)sec->FPanY;
		topptr = dplc;
		botptr = dmost;
	}

	if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
//	if (picanm[globalpicnum]&192) globalpicnum += animateoffs(globalpicnum,(short)sectnum);
	if(SOFT_Tiles[globalpicnum] == NULL)
	{
		SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
		XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
		picsiz[globalpicnum] = ((char)j);
		j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
		picsiz[globalpicnum] += ((char)(j<<4));
	}
	globalshiftval = (picsiz[globalpicnum]>>4);
	if (pow2long[globalshiftval] != SOFT_Tiles[globalpicnum]->Height) globalshiftval++;
	globalshiftval = 32-globalshiftval;
	globalzd = (((SOFT_Tiles[globalpicnum]->Width>>1)+parallaxyoffs)<<globalshiftval)+(globalypanning<<24);
	globalyscale = (8<<(globalshiftval-19));
	//if (globalorientation&256) globalyscale = -globalyscale, globalzd = -globalzd;

	k = 11 - (picsiz[globalpicnum]&15) - pskybits;
	x = -1;

	for(z=bunchfirst[bunch];z>=0;z=p2[z])
	{
		wallnum = thewall[z]; nextsectnum = SOFT_Map.Wall[wallnum].NextSector;

		if (dastat == 0) j = SOFT_Map.Sector[nextsectnum].CStat;
						else j = SOFT_Map.Sector[nextsectnum].FStat;

		if ((nextsectnum < 0) || (SOFT_Map.Wall[wallnum].CStat&32) || ((j&1) == 0))
		{
			if (x == -1) x = xb1[z];

			if (parallaxtype == 0)
			{
				n = mulscale16(xdimenrecip,viewingrange);
				for(j=xb1[z];j<=xb2[z];j++)
					lplc[j] = (((mulscale23(j-halfxdimen,n)+globalang)&2047)>>k);
			}
			else
			{
				for(j=xb1[z];j<=xb2[z];j++)
					lplc[j] = ((((long)radarang2[j]+globalang)&2047)>>k);
			}
			if (parallaxtype == 2)
			{
				n = mulscale16(xdimscale,viewingrange);
				for(j=xb1[z];j<=xb2[z];j++)
					swplc[j] = mulscale14(sintable[((long)radarang2[j]+512)&2047],n);
			}
			else
				//clearbuf((long)(&swplc[xb1[z]]),xb2[z]-xb1[z]+1,mulscale16(xdimscale,viewingrange));
				memset(&swplc[xb1[z]], mulscale16(xdimscale,viewingrange), xb2[z]-xb1[z]+1);  
		}
		else if (x >= 0)
		{
			l = globalpicnum; m = (picsiz[globalpicnum]&15);
			globalpicnum = l+pskyoff[lplc[x]>>m];

			if (((lplc[x]^lplc[xb1[z]-1])>>m) == 0)
				wallscan(x,xb1[z]-1,topptr,botptr,swplc,lplc);
			else
			{
				j = x;
				while (x < xb1[z])
				{
					n = l+pskyoff[lplc[x]>>m];
					if (n != globalpicnum)
					{
						wallscan(j,x-1,topptr,botptr,swplc,lplc);
						j = x;
						globalpicnum = n;
					}
					x++;
				}
				if (j < x)
					wallscan(j,x-1,topptr,botptr,swplc,lplc);
			}

			globalpicnum = l;
			x = -1;
		}
	}

	if (x >= 0)
	{
		l = globalpicnum; m = (picsiz[globalpicnum]&15);
		globalpicnum = l+pskyoff[lplc[x]>>m];

		if (((lplc[x]^lplc[xb2[bunchlast[bunch]]])>>m) == 0)
			wallscan(x,xb2[bunchlast[bunch]],topptr,botptr,swplc,lplc);
		else
		{
			j = x;
			while (x <= xb2[bunchlast[bunch]])
			{
				n = l+pskyoff[lplc[x]>>m];
				if (n != globalpicnum)
				{
					wallscan(j,x-1,topptr,botptr,swplc,lplc);
					j = x;
					globalpicnum = n;
				}
				x++;
			}
			if (j <= x)
				wallscan(j,x,topptr,botptr,swplc,lplc);
		}
		globalpicnum = l;
	}
	globalhoriz = globalhorizbak;
}

void prepwall(long z, XBUILD_MAP_WALL *wal)
{
	long i, l, ol, splc, sinc, x, topinc, top, botinc, bot, hplc, walxrepeat;

	walxrepeat = (wal->RepX<<3);

		//lwall calculation
	i = xb1[z]-halfxdimen;
	topinc = -(ry1[z]>>2);
	botinc = ((ry2[z]-ry1[z])>>8);
	top = mulscale5(rx1[z],xdimen)+mulscale2(topinc,i);
	bot = mulscale11(rx1[z]-rx2[z],xdimen)+mulscale2(botinc,i);

	splc = mulscale19(ry1[z],xdimscale);
	sinc = mulscale16(ry2[z]-ry1[z],xdimscale);

	x = xb1[z];
	if (bot != 0)
	{
		l = divscale12(top,bot);
		swall[x] = mulscale21(l,sinc)+splc;
		l *= walxrepeat;
		lwall[x] = (l>>18);
	}
	while (x+4 <= xb2[z])
	{
		top += topinc; bot += botinc;
		if (bot != 0)
		{
			ol = l; l = divscale12(top,bot);
			swall[x+4] = mulscale21(l,sinc)+splc;
			l *= walxrepeat;
			lwall[x+4] = (l>>18);
		}
		i = ((ol+l)>>1);
		lwall[x+2] = (i>>18);
		lwall[x+1] = ((ol+i)>>19);
		lwall[x+3] = ((l+i)>>19);
		swall[x+2] = ((swall[x]+swall[x+4])>>1);
		swall[x+1] = ((swall[x]+swall[x+2])>>1);
		swall[x+3] = ((swall[x+4]+swall[x+2])>>1);
		x += 4;
	}
	if (x+2 <= xb2[z])
	{
		top += (topinc>>1); bot += (botinc>>1);
		if (bot != 0)
		{
			ol = l; l = divscale12(top,bot);
			swall[x+2] = mulscale21(l,sinc)+splc;
			l *= walxrepeat;
			lwall[x+2] = (l>>18);
		}
		lwall[x+1] = ((l+ol)>>19);
		swall[x+1] = ((swall[x]+swall[x+2])>>1);
		x += 2;
	}
	if (x+1 <= xb2[z])
	{
		bot += (botinc>>2);
		if (bot != 0)
		{
			l = divscale12(top+(topinc>>2),bot);
			swall[x+1] = mulscale21(l,sinc)+splc;
			lwall[x+1] = mulscale18(l,walxrepeat);
		}
	}

	if (lwall[xb1[z]] < 0) lwall[xb1[z]] = 0;
	if ((lwall[xb2[z]] >= walxrepeat) && (walxrepeat)) lwall[xb2[z]] = walxrepeat-1;
	if (wal->CStat&8)
	{
		walxrepeat--;
		for(x=xb1[z];x<=xb2[z];x++) lwall[x] = walxrepeat-lwall[x];
	}
}

void drawalls (long bunch)
{
	XBUILD_MAP_SECTOR *sec, *nextsec;
	XBUILD_MAP_WALL *wal;
	long i, j, k, l, m, n, x, y, x1, x2, cz[5], fz[5];
	long z, wallnum, sectnum, nextsectnum, globalhorizbak;
	long startsmostwallcnt, startsmostcnt, gotswall;
	char andwstat1, andwstat2;

	z = bunchfirst[bunch];
	sectnum = thesector[z]; sec = &SOFT_Map.Sector[sectnum];

	andwstat1 = 0xff; andwstat2 = 0xff;
	for(;z>=0;z=p2[z])  //uplc/dplc calculation
	{
		andwstat1 &= wallmost(uplc,z,sectnum,(char)0);
		andwstat2 &= wallmost(dplc,z,sectnum,(char)1);
	}

	if ((andwstat1&3) != 3)     //draw ceilings
	{
		if ((sec->CStat&3) == 2)
		{
			//grouscan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum,0);
		}
		else if ((sec->CStat&1) == 0)
		{
			ceilscan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum);
		}
		else
		{
			parascan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum,0,bunch);
		}
	}
	if ((andwstat2&12) != 12)   //draw floors
	{
		if ((sec->FStat&3) == 2)
		{
			//grouscan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum,1);
		}
		else if ((sec->FStat&1) == 0)
		{
			florscan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum);
		}
		else
		{
			parascan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum,1,bunch);
		}
	}
	//DRAW WALLS SECTION!
	for(z=bunchfirst[bunch];z>=0;z=p2[z])
	{
		x1 = xb1[z]; x2 = xb2[z];
		if (umost[x2] >= dmost[x2])
		{
			for(x=x1;x<x2;x++)
				if (umost[x] < dmost[x]) break;
			if (x >= x2)
			{
				smostwall[smostwallcnt] = z;
				smostwalltype[smostwallcnt] = 0;
				smostwallcnt++;
				continue;
			}
		}

		wallnum = thewall[z]; wal = &SOFT_Map.Wall[wallnum];
		nextsectnum = wal->NextSector; nextsec = &SOFT_Map.Sector[nextsectnum];

		gotswall = 0;

		startsmostwallcnt = smostwallcnt;
		startsmostcnt = smostcnt;

		if ((searchit == 2) && (searchx >= x1) && (searchx <= x2))
		{
			if (searchy <= uplc[searchx]) //ceiling
			{
				searchsector = sectnum; searchwall = wallnum;
				searchstat = 1; searchit = 1;
			}
			else if (searchy >= dplc[searchx]) //floor
			{
				searchsector = sectnum; searchwall = wallnum;
				searchstat = 2; searchit = 1;
			}
		}

		if (nextsectnum >= 0)
		{
			getzsofslope((short)sectnum,wal->X,wal->Y,&cz[0],&fz[0]);
			getzsofslope((short)sectnum,SOFT_Map.Wall[wal->Point2].X,SOFT_Map.Wall[wal->Point2].Y,&cz[1],&fz[1]);
			getzsofslope((short)nextsectnum,wal->X,wal->Y,&cz[2],&fz[2]);
			getzsofslope((short)nextsectnum,SOFT_Map.Wall[wal->Point2].X,SOFT_Map.Wall[wal->Point2].Y,&cz[3],&fz[3]);
			getzsofslope((short)nextsectnum,globalposx,globalposy,&cz[4],&fz[4]);

			if ((wal->CStat&48) == 16) maskwall[maskwallcnt++] = z;

			if (((sec->CStat&1) == 0) || ((nextsec->CStat&1) == 0))
			{
				if ((cz[2] <= cz[0]) && (cz[3] <= cz[1]))
				{
					if (globparaceilclip)
						for(x=x1;x<=x2;x++)
							if (uplc[x] > umost[x])
								if (umost[x] <= dmost[x])
								{
									umost[x] = uplc[x];
									if (umost[x] > dmost[x]) numhits--;
								}
				}
				else
				{
					wallmost(dwall,z,nextsectnum,(char)0);
					if ((cz[2] > fz[0]) || (cz[3] > fz[1]))
						for(i=x1;i<=x2;i++) if (dwall[i] > dplc[i]) dwall[i] = dplc[i];

					if ((searchit == 2) && (searchx >= x1) && (searchx <= x2))
						if (searchy <= dwall[searchx]) //wall
						{
							searchsector = sectnum; searchwall = wallnum;
							searchstat = 0; searchit = 1;
						}

					globalorientation = (long)wal->CStat;
					globalpicnum = wal->Pic;
					if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
					if(SOFT_Tiles[globalpicnum] == NULL)
					{
						SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
						XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
						j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
						picsiz[globalpicnum] = ((char)j);
						j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
						picsiz[globalpicnum] += ((char)(j<<4));
					}
					globalxpanning = (long)wal->PanX;
					globalypanning = (long)wal->PanY;
					globalshiftval = (picsiz[globalpicnum]>>4);
					if (pow2long[globalshiftval] != SOFT_Tiles[globalpicnum]->Height) globalshiftval++;
					globalshiftval = 32-globalshiftval;
					//if (picanm[globalpicnum]&192) globalpicnum += animateoffs(globalpicnum,(short)wallnum+16384);
					globalshade = (long)wal->Shade;
					globvis = globalvisibility;
					if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));
					globalpal = (long)wal->Pal;
					globalyscale = (wal->RepY<<(globalshiftval-19));
					if ((globalorientation&4) == 0)
						globalzd = (((globalposz-nextsec->CZ)*globalyscale)<<8);
					else
						globalzd = (((globalposz-sec->CZ)*globalyscale)<<8);
					globalzd += (globalypanning<<24);
					if (globalorientation&256) globalyscale = -globalyscale, globalzd = -globalzd;

					if (gotswall == 0) { gotswall = 1; prepwall(z,wal); }
					wallscan(x1,x2,uplc,dwall,swall,lwall);

					if ((cz[2] >= cz[0]) && (cz[3] >= cz[1]))
					{
						for(x=x1;x<=x2;x++)
							if (dwall[x] > umost[x])
								if (umost[x] <= dmost[x])
								{
									umost[x] = dwall[x];
									if (umost[x] > dmost[x]) numhits--;
								}
					}
					else
					{
						for(x=x1;x<=x2;x++)
							if (umost[x] <= dmost[x])
							{
								i = max(uplc[x],dwall[x]);
								if (i > umost[x])
								{
									umost[x] = i;
									if (umost[x] > dmost[x]) numhits--;
								}
							}
					}
				}
				if ((cz[2] < cz[0]) || (cz[3] < cz[1]) || (globalposz < cz[4]))
				{
					i = x2-x1+1;
					if (smostcnt+i < MAXYSAVES)
					{
						smoststart[smostwallcnt] = smostcnt;
						smostwall[smostwallcnt] = z;
						smostwalltype[smostwallcnt] = 1;   //1 for umost
						smostwallcnt++;
						//copybufbyte((long)&umost[x1],(long)&smost[smostcnt],i*sizeof(smost[0]));
						memcpy(&umost[x1], &smost[smostcnt], i * sizeof(smost[0]));
						smostcnt += i;
					}
				}
			}
			if (((sec->FStat&1) == 0) || ((nextsec->FStat&1) == 0))
			{
				if ((fz[2] >= fz[0]) && (fz[3] >= fz[1]))
				{
					if (globparaflorclip)
						for(x=x1;x<=x2;x++)
							if (dplc[x] < dmost[x])
								if (umost[x] <= dmost[x])
								{
									dmost[x] = dplc[x];
									if (umost[x] > dmost[x]) numhits--;
								}
				}
				else
				{
					wallmost(uwall,z,nextsectnum,(char)1);
					if ((fz[2] < cz[0]) || (fz[3] < cz[1]))
						for(i=x1;i<=x2;i++) if (uwall[i] < uplc[i]) uwall[i] = uplc[i];

					if ((searchit == 2) && (searchx >= x1) && (searchx <= x2))
						if (searchy >= uwall[searchx]) //wall
						{
							searchsector = sectnum; searchwall = wallnum;
							if ((wal->CStat&2) > 0) searchwall = wal->NextWall;
							searchstat = 0; searchit = 1;
						}

					if ((wal->CStat&2) > 0)
					{
						wallnum = wal->NextWall; wal = &SOFT_Map.Wall[wallnum];
						globalorientation = (long)wal->CStat;
						globalpicnum = wal->Pic;
						//GRAB PIC HERE TOO//
						if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
						if(SOFT_Tiles[globalpicnum] == NULL)
						{
							SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
							XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
							j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
							picsiz[globalpicnum] = ((char)j);
							j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
							picsiz[globalpicnum] += ((char)(j<<4));
						}
						globalxpanning = (long)wal->PanX;
						globalypanning = (long)wal->PanY;
						//if (picanm[globalpicnum]&192) globalpicnum += animateoffs(globalpicnum,(short)wallnum+16384);
						globalshade = (long)wal->Shade;
						globalpal = (long)wal->Pal;
						wallnum = thewall[z]; wal = &SOFT_Map.Wall[wallnum];
					}
					else
					{
						globalorientation = (long)wal->CStat;
						globalpicnum = wal->Pic;
						//GRAB PIC HERE TOO//
						if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
						if(SOFT_Tiles[globalpicnum] == NULL)
						{
							SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
							XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
							j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
							picsiz[globalpicnum] = ((char)j);
							j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
							picsiz[globalpicnum] += ((char)(j<<4));
						}
						globalxpanning = (long)wal->PanX;
						globalypanning = (long)wal->PanY;
						//if (picanm[globalpicnum]&192) globalpicnum += animateoffs(globalpicnum,(short)wallnum+16384);
						globalshade = (long)wal->Shade;
						globalpal = (long)wal->Pal;
					}
					globvis = globalvisibility;
					if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));
					globalshiftval = (picsiz[globalpicnum]>>4);
					if (pow2long[globalshiftval] != SOFT_Tiles[globalpicnum]->Height) globalshiftval++;
					globalshiftval = 32-globalshiftval;
					globalyscale = (wal->RepY<<(globalshiftval-19));
					if ((globalorientation&4) == 0)
						globalzd = (((globalposz-nextsec->FZ)*globalyscale)<<8);
					else
						globalzd = (((globalposz-sec->CZ)*globalyscale)<<8);
					globalzd += (globalypanning<<24);
					if (globalorientation&256) globalyscale = -globalyscale, globalzd = -globalzd;

					if (gotswall == 0) { gotswall = 1; prepwall(z,wal); }
					wallscan(x1,x2,uwall,dplc,swall,lwall);

					if ((fz[2] <= fz[0]) && (fz[3] <= fz[1]))
					{
						for(x=x1;x<=x2;x++)
							if (uwall[x] < dmost[x])
								if (umost[x] <= dmost[x])
								{
									dmost[x] = uwall[x];
									if (umost[x] > dmost[x]) numhits--;
								}
					}
					else
					{
						for(x=x1;x<=x2;x++)
							if (umost[x] <= dmost[x])
							{
								i = min(dplc[x],uwall[x]);
								if (i < dmost[x])
								{
									dmost[x] = i;
									if (umost[x] > dmost[x]) numhits--;
								}
							}
					}
				}
				if ((fz[2] > fz[0]) || (fz[3] > fz[1]) || (globalposz > fz[4]))
				{
					i = x2-x1+1;
					if (smostcnt+i < MAXYSAVES)
					{
						smoststart[smostwallcnt] = smostcnt;
						smostwall[smostwallcnt] = z;
						smostwalltype[smostwallcnt] = 2;   //2 for dmost
						smostwallcnt++;
						//copybufbyte((long)&dmost[x1],(long)&smost[smostcnt],i*sizeof(smost[0]));
						memcpy(&dmost[x1], &smost[smostcnt], i * sizeof(smost[0]));
						smostcnt += i;
					}
				}
			}
			if (numhits < 0) return;
			if ((!(wal->CStat&32)) && ((gotsector[nextsectnum>>3]&pow2char[nextsectnum&7]) == 0))
			{
				if (umost[x2] < dmost[x2])
					scansector(nextsectnum);
				else
				{
					for(x=x1;x<x2;x++)
						if (umost[x] < dmost[x])
							{ scansector(nextsectnum); break; }

						//If can't see sector beyond, then cancel smost array and just
						//store wall!
					if (x == x2)
					{
						smostwallcnt = startsmostwallcnt;
						smostcnt = startsmostcnt;
						smostwall[smostwallcnt] = z;
						smostwalltype[smostwallcnt] = 0;
						smostwallcnt++;
					}
				}
			}
		}
		if ((nextsectnum < 0) || (wal->CStat&32))   //White/1-way wall
		{
			globalorientation = (long)wal->CStat;
			if (nextsectnum < 0) globalpicnum = wal->Pic;
								  else globalpicnum = wal->OverPic;
			if ((unsigned)globalpicnum >= (unsigned)MAXTILES) globalpicnum = 0;
			if(SOFT_Tiles[globalpicnum] == NULL)
			{
				SOFT_Tiles[globalpicnum] = new XBUILD_ART_TILEDATA;
				XBUILD_ART_GetTileData(globalpicnum, SOFT_Tiles[globalpicnum]);
				j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Width)) j--;
				picsiz[globalpicnum] = ((char)j);
				j = 15; while ((j > 1) && (pow2long[j] > SOFT_Tiles[globalpicnum]->Height)) j--;
				picsiz[globalpicnum] += ((char)(j<<4));
			}
			globalxpanning = (long)wal->PanX;
			globalypanning = (long)wal->PanY;
			//if (picanm[globalpicnum]&192) globalpicnum += animateoffs(globalpicnum,(short)wallnum+16384);
			globalshade = (long)wal->Shade;
			globvis = globalvisibility;
			if (sec->Visibility != 0) globvis = mulscale4(globvis,(long)((unsigned char)(sec->Visibility+16)));
			globalpal = (long)wal->Pal;
			globalshiftval = (picsiz[globalpicnum]>>4);
			if (pow2long[globalshiftval] != SOFT_Tiles[globalpicnum]->Height) globalshiftval++;
			globalshiftval = 32-globalshiftval;
			globalyscale = (wal->RepY<<(globalshiftval-19));
			if (nextsectnum >= 0)
			{
				if ((globalorientation&4) == 0) globalzd = globalposz-nextsec->CZ;
													else globalzd = globalposz-sec->CZ;
			}
			else
			{
				if ((globalorientation&4) == 0) globalzd = globalposz-sec->CZ;
													else globalzd = globalposz-sec->FZ;
			}
			globalzd = ((globalzd*globalyscale)<<8) + (globalypanning<<24);
			if (globalorientation&256) globalyscale = -globalyscale, globalzd = -globalzd;

			if (gotswall == 0) { gotswall = 1; prepwall(z,wal); }
			wallscan(x1,x2,uplc,dplc,swall,lwall);

			for(x=x1;x<=x2;x++)
				if (umost[x] <= dmost[x])
					{ umost[x] = 1; dmost[x] = 0; numhits--; }
			smostwall[smostwallcnt] = z;
			smostwalltype[smostwallcnt] = 0;
			smostwallcnt++;

			if ((searchit == 2) && (searchx >= x1) && (searchx <= x2))
			{
				searchit = 1; searchsector = sectnum; searchwall = wallnum;
				if (nextsectnum < 0) searchstat = 0; else searchstat = 4;
			}
		}
	}
}

void drawrooms(long daposx, long daposy, long daposz,
			 short daang, long dahoriz, short dacursectnum)
{
	long i, j, z, cz, fz, closest;
	short *shortptr1, *shortptr2;

	beforedrawrooms = 0;
	totalarea += (windowx2+1-windowx1)*(windowy2+1-windowy1);

	globalposx = daposx; globalposy = daposy; globalposz = daposz;
	globalang = (daang&2047);

	globalhoriz = mulscale16(dahoriz-100,xdimenscale)+(ydimen>>1);
	globaluclip = (0-globalhoriz)*xdimscale;
	globaldclip = (ydimen-globalhoriz)*xdimscale;

	i = mulscale16(xdimenscale,viewingrangerecip);
	globalpisibility = mulscale16(parallaxvisibility,i);
	globalvisibility = mulscale16(visibility,i);
	globalhisibility = mulscale16(globalvisibility,xyaspect);
	globalcisibility = mulscale8(globalhisibility,320);

	globalcursectnum = dacursectnum;
	totalclocklock = totalclock;
	
	cosglobalang = sintable[(globalang + 512) & 2047];
	singlobalang = sintable[globalang&2047];
	cosviewingrangeglobalang = mulscale16(cosglobalang,viewingrange);
	sinviewingrangeglobalang = mulscale16(singlobalang,viewingrange);

	if ((xyaspect != oxyaspect) || (xdimen != oxdimen) || (viewingrange != oviewingrange))
		dosetaspect();

	frameoffset = frameplace+viewoffset;

	//clearbufbyte((long)(&gotsector[0]),(long)((numsectors+7)>>3),0L);
	memset(&gotsector[0], 0, ((SOFT_Map.Mapinfo.SectorNumber + 7) >> 3));
	shortptr1 = (short *)&startumost[windowx1];
	shortptr2 = (short *)&startdmost[windowx1];
	i = xdimen-1;
	do
	{
		umost[i] = shortptr1[i]-windowy1;
		dmost[i] = shortptr2[i]-windowy1;
		i--;
	} while (i != 0);
	umost[0] = shortptr1[0]-windowy1;
	dmost[0] = shortptr2[0]-windowy1;

//	if (smostwallcnt < 0) 

	numhits = xdimen; numscans = 0; numbunches = 0;
	maskwallcnt = 0; smostwallcnt = 0; smostcnt = 0; spritesortcnt = 0;

	if (globalcursectnum >= MAXSECTORS)
		globalcursectnum -= MAXSECTORS;
	else
	{
		i = globalcursectnum;
		updatesector(globalposx,globalposy,&globalcursectnum);
		if (globalcursectnum < 0) globalcursectnum = i;
	}

	globparaceilclip = 1;
	globparaflorclip = 1;
	getzsofslope(globalcursectnum,globalposx,globalposy,&cz,&fz);
	if (globalposz < cz) globparaceilclip = 0;
	if (globalposz > fz) globparaflorclip = 0;

	scansector(globalcursectnum);

	/*if (inpreparemirror)
	{
		inpreparemirror = 0;
		mirrorsx1 = xdimen-1; mirrorsx2 = 0;
		for(i=numscans-1;i>=0;i--)
		{
			if (wall[thewall[i]].nextsector < 0) continue;
			if (xb1[i] < mirrorsx1) mirrorsx1 = xb1[i];
			if (xb2[i] > mirrorsx2) mirrorsx2 = xb2[i];
		}

		if (stereomode)
		{
			mirrorsx1 += (stereopixelwidth<<1);
			mirrorsx2 += (stereopixelwidth<<1);
		}

		for(i=0;i<mirrorsx1;i++)
			if (umost[i] <= dmost[i])
				{ umost[i] = 1; dmost[i] = 0; numhits--; }
		for(i=mirrorsx2+1;i<xdimen;i++)
			if (umost[i] <= dmost[i])
				{ umost[i] = 1; dmost[i] = 0; numhits--; }

		drawalls(0L);
		numbunches--;
		bunchfirst[0] = bunchfirst[numbunches];
		bunchlast[0] = bunchlast[numbunches];

		mirrorsy1 = min(umost[mirrorsx1],umost[mirrorsx2]);
		mirrorsy2 = max(dmost[mirrorsx1],dmost[mirrorsx2]);
	}*/

	while ((numbunches > 0) && (numhits > 0))
	{
		memset(tempbuf, 0, (numbunches+3)>>2);
		//clearbuf((long)(&tempbuf[0]),(long)((numbunches+3)>>2),0L);
		tempbuf[0] = 1;

		closest = 0;              //Almost works, but not quite :(
		for(i=1;i<numbunches;i++)
		{
			if ((j = bunchfront(i,closest)) < 0) continue;
			tempbuf[i] = 1;
			if (j == 0) tempbuf[closest] = 1, closest = i;
		}
		for(i=0;i<numbunches;i++) //Double-check
		{
			if (tempbuf[i]) continue;
			if ((j = bunchfront(i,closest)) < 0) continue;
			tempbuf[i] = 1;
			if (j == 0) tempbuf[closest] = 1, closest = i, i = 0;
		}

		drawalls(closest);

		/*if (automapping)
		{
			for(z=bunchfirst[closest];z>=0;z=p2[z])
				show2dwall[thewall[z]>>3] |= pow2char[thewall[z]&7];
		}*/

		numbunches--;
		bunchfirst[closest] = bunchfirst[numbunches];
		bunchlast[closest] = bunchlast[numbunches];
	}
}
