// CtrlConsole.cpp: implementation of the CCtrlConsole class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "glDuke.h"
#include "CtrlConsole.h"
#include "CtrlGame.h"
#include "Settings.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CSettings set;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCtrlConsole::CCtrlConsole()
{

}

CCtrlConsole::~CCtrlConsole()
{

}

int ConsoleCallback(char* lpstrCommand, void *lpParam)
{
	CCtrlConsole *c;
	c = (CCtrlConsole*)lpParam;
	int i;
	if(!strcmp(lpstrCommand, "list volumename"))
	{
		for(i = 0; i < c->pGame->c->nDefineVolumenameCount; i++)
		{
			XBUILD_CONSOLE_PrintFormatted("%i = %s\r\n", c->pGame->c->DefineVolumename[i].nNumber, c->pGame->c->DefineVolumename[i].strName);
		}
		return 1;
	}
	else if(!strcmp(lpstrCommand, "list state"))
	{
		for(i = 0; i < c->pGame->c->nStateCount; i++)
		{
			XBUILD_CONSOLE_PrintFormatted("%s\r\n", c->pGame->c->State[i].strName);
		}
		return 1;
	}
	return 0;
}

void CCtrlConsole::PassControlFocus(CGame *g)
{
	pGame = g;
	pGame->nControlFocus = CONTROL_FOCUS_CONSOLE;
	XBUILD_CONSOLE_ShowTextConsole(FALSE);
	XBUILD_CONSOLE_SetConsoleCallback((void*)ConsoleCallback, (void*)this);
	/*
	XBUILD_CONSOLE_GetGraphicConsole(&m_Console);
	XBUILD_GFX_SetDisplayList(XBUILD_GFX_LAYER_CONSOLE, &m_Console);
	//A get status function would be cool here
	XBUILD_GFX_SetStatus(XBUILD_GFX_LAYER_3DMAP | XBUILD_GFX_LAYER_STATUS | XBUILD_GFX_LAYER_CONSOLE);
	*/
}

void CCtrlConsole::Update()
{
	if(set.m_Setup.dwControlStatus & 0x01)
	{
		pGame->diw.UpdateKeyboardData();
		if(nCheckKey != 0)
		{
			if(!(pGame->diw.lpKeyboardData[nCheckKey] & 0x80))
			{
				nCheckKey = 0;
			}
			else
			{
				pGame->diw.lpKeyboardData[nCheckKey] &= ~0x80;
			}
		}
		if(pGame->diw.lpKeyboardData[DIK_GRAVE] & 0x80)
		{
			//Give input control back to the game
			((CCtrlGame*)pGame->pCtrlGame)->PassControlFocus(pGame);
			((CCtrlGame*)pGame->pCtrlGame)->nCheckKey = DIK_GRAVE;
			XBUILD_GFX_SetStatus(XBUILD_GFX_LAYER_3DMAP | XBUILD_GFX_LAYER_STATUS);
			XBUILD_CONSOLE_HideTextConsole();
		}
	}
}