// CtrlGame.cpp: implementation of the CCtrlGame class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "glDuke.h"
#include "CtrlGame.h"
#include "Settings.h"
#include "glDukeControls.h"
#include "CtrlConsole.h"
#include <MATH.H>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CSettings set;
#define PI 3.1415927
#define SPEED 0x450

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCtrlGame::CCtrlGame()
{
	nCheckKey = 0;
	nJumping = 0;
	nFalling = 0;
	nJumpingNoSound = 0;
	nClipping = 1;
}

CCtrlGame::~CCtrlGame()
{

}

#define CLIPMASK0 (((1L)<<16)+1L)
#define CLIPMASK1 (((256L)<<16)+64L)
#define DUKEFDIST 4 << 10
#define DUKECDIST 4 << 2

void GameFunc_MoveForward(CCtrlGame *c)
{
	int xvect;
	int zvect;
	short s;
	xvect = (SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2560)&2047))>>3;
	zvect = (SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2048)&2047))>>3;
	s = XBUILD_ANIMATE_GetCurrentSector();
	if(c->nClipping)
	{
		c->pGame->Y <<= 4;
		XBUILD_ANIMATE_ClipMove((long*)&c->pGame->X, (long*)&c->pGame->Z, (long*)&c->pGame->Y, &s, xvect, zvect, 128, DUKECDIST, DUKEFDIST, CLIPMASK0);
		c->pGame->Y >>= 4;
	}
	else
	{
		c->pGame->X += (xvect >> 14);
		c->pGame->Z += (zvect >> 14);
	}
}

void GameFunc_MoveBackward(CCtrlGame *c)
{
	int xvect;
	int zvect;
	short s;
	xvect = (-SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2560)&2047))>>3;
	zvect = (-SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2048)&2047))>>3;
	s = XBUILD_ANIMATE_GetCurrentSector();
	if(c->nClipping)
	{
		c->pGame->Y <<= 4;
		XBUILD_ANIMATE_ClipMove((long*)&c->pGame->X, (long*)&c->pGame->Z, (long*)&c->pGame->Y, &s, xvect, zvect, 128, DUKECDIST, DUKEFDIST, CLIPMASK0);
		c->pGame->Y >>= 4;
	}
	else
	{
		c->pGame->X += (xvect >> 14);
		c->pGame->Z += (zvect >> 14);
	}
}

void GameFunc_TurnLeft(CCtrlGame *c)
{
	c->pGame->YAngle -= 48;
	c->pGame->YAngle &= 0x7FF;
}

void GameFunc_TurnRight(CCtrlGame *c)
{
	c->pGame->YAngle += 48;
	c->pGame->YAngle &= 0x7FF;
}

void GameFunc_Strafe(CCtrlGame *c)
{
	//nStrafing = 1;
}

void GameFunc_Fire(CCtrlGame *c)
{
	short angx, angy, angz;
	short sect, wall, sprite;
	long x, y, z;
	angx = XBUILD_ANIMATE_GetValueFromSinTable(c->pGame->YAngle + 512);
	angy = XBUILD_ANIMATE_GetValueFromSinTable(c->pGame->YAngle);
	angz = 0;
	XBUILD_SOUND_Play(c->pGame->c->DefineSound[c->pGame->GetCorrectSoundNumber(3)].strFilename, FALSE);
	XBUILD_ANIMATE_HitScan(c->pGame->X, c->pGame->Z, c->pGame->Y << 4, XBUILD_ANIMATE_GetCurrentSector(), angx, angy, angz, &sect, &wall, &sprite, &x, &y, &z, CLIPMASK0);
	//Spawn a sprite instead of changing one :P
	c->pGame->pMap->Sprite[0].Pic = 952;
	c->pGame->pMap->Sprite[0].X = x;
	c->pGame->pMap->Sprite[0].Y = y;
	c->pGame->pMap->Sprite[0].Z = z >> 4;
	c->pGame->pMap->Sprite[0].RepX = 2;
	c->pGame->pMap->Sprite[0].RepY = 2;
	c->pGame->pMap->Sprite[0].CStat &= 0x7FFF;
}

void GameFunc_Open(CCtrlGame *c)
{
	short nsect = -1;
	short nwall = -1;
	short nsprt = -1;
	long  ndist;
	c->nCheckKey = set.m_Setup.nControls[6];
	c->pGame->ActivateSectorTag(XBUILD_ANIMATE_GetCurrentSector(), 0);
	XBUILD_ANIMATE_NearTag(c->pGame->X, c->pGame->Z, c->pGame->Y << 4, XBUILD_ANIMATE_GetCurrentSector(), c->pGame->YAngle, &nsect, &nwall, &nsprt, &ndist, 1024, 1);
	if(nsect != -1)
	{
		//Should check for an activator sprite in the area
		c->pGame->ActivateSectorTag(nsect, 0);
	}
	if(nsprt != -1)
	{
		XBUILD_SOUND_Play(c->pGame->c->DefineSound[c->pGame->GetCorrectSoundNumber(c->pGame->pMap->Sprite[nsprt].HiTag)].strFilename, 0);
	}
}

void GameFunc_Run(CCtrlGame *c)
{
//	nRunning = 1;
}

void GameFunc_Jump(CCtrlGame *c)
{
	int i;
	i = XBUILD_ANIMATE_GetCurrentSector();
	if(c->pGame->nUnderwater)
	{
		if(c->pGame->Y == (XBUILD_ANIMATE_GetCeilingHeight(i, c->pGame->X, c->pGame->Z) + 300))
		{
			XBUILDDISPLAYELEMENT_FILTER Filter;
			int nSE;
			nSE = XBUILD_ANIMATE_LookForSpriteInSector(i, 1, 7);
			if(nSE == -1)
			{
				//Forget it
				return;
			}
			c->pGame->ActivateSectorEffector(nSE, i);
			c->pGame->nUnderwater = 0;
			c->pGame->Y = XBUILD_ANIMATE_GetFloorHeight(XBUILD_ANIMATE_GetCurrentSector(), c->pGame->X, c->pGame->Z) - 500;
			Filter.R = 0;
			Filter.G = 0;
			Filter.B = 0;
			Filter.A = 0;
			memcpy(c->pGame->m_Status.Element[STATUS_BASE_ELEMENT_COUNT - 1].pData, &Filter, sizeof(XBUILDDISPLAYELEMENT_FILTER));
			XBUILD_GFX_SetDisplayList(XBUILD_GFX_LAYER_STATUS, &c->pGame->m_Status);
			//Should make a breathing sound here (just gotta find it)
			XBUILD_SOUND_Stop(c->nWaterSound);
			return;
		}
		c->pGame->Y -= 100;
		if(c->pGame->Y < (XBUILD_ANIMATE_GetCeilingHeight(i, c->pGame->X, c->pGame->Y) + 300))
		{
			c->pGame->Y = XBUILD_ANIMATE_GetCeilingHeight(i, c->pGame->X, c->pGame->Z) + 300;	
		}
	}
	else if(c->nJumping == 0 && XBUILD_INCREMENTATOR_IsIncrementDead(c->nJumpingIncrem))
	{
		int nMaxHeight;
		c->nJumpingHeight = XBUILD_ANIMATE_GetFloorHeight(i, c->pGame->X, c->pGame->Z) - 500;
		nMaxHeight = XBUILD_ANIMATE_GetFloorHeight(i, c->pGame->X, c->pGame->Z) - 2000;
		if(nMaxHeight <= XBUILD_ANIMATE_GetCeilingHeight(i, c->pGame->X, c->pGame->Z))
		{
			nMaxHeight = XBUILD_ANIMATE_GetCeilingHeight(i, c->pGame->X, c->pGame->Z);
		}
		c->nJumpingIncrem = XBUILD_INCREMENTATOR_Add(&c->nJumpingHeight, -4, nMaxHeight, NULL, NULL); 
		c->nJumping = 1;
	}
}

void GameFunc_Crouch(CCtrlGame *c)
{
	int a, nSE;
	a = XBUILD_ANIMATE_GetCurrentSector();
	if(c->pGame->nUnderwater)
	{
		c->pGame->Y += 100;
		if(c->pGame->Y > (XBUILD_ANIMATE_GetFloorHeight(a, c->pGame->X, c->pGame->Z) - 300))
		{
			c->pGame->Y = XBUILD_ANIMATE_GetFloorHeight(a, c->pGame->X, c->pGame->Z) - 300;	
		}
	}
	if(c->pGame->pMap->Sector[a].LoTag == 1 && !c->nJumping && !c->nFalling)
	{
		//ST 1 : Water
		XBUILDDISPLAYELEMENT_FILTER Filter;
		nSE = XBUILD_ANIMATE_LookForSpriteInSector(a, 1, 7);
		if(nSE == -1)
		{
			//Forget it
			return;
		}
		c->pGame->ActivateSectorEffector(nSE, a);
		c->pGame->nUnderwater = 1;
		c->pGame->Y = XBUILD_ANIMATE_GetCeilingHeight(XBUILD_ANIMATE_GetCurrentSector(), c->pGame->X, c->pGame->Z) + 200;
		Filter.R = 0;
		Filter.G = 0;
		Filter.B = 0xFF;
		Filter.A = 0x4C;
		memcpy(c->pGame->m_Status.Element[STATUS_BASE_ELEMENT_COUNT - 1].pData, &Filter, sizeof(XBUILDDISPLAYELEMENT_FILTER));
		XBUILD_GFX_SetDisplayList(XBUILD_GFX_LAYER_STATUS, &c->pGame->m_Status);
		c->nWaterSound = XBUILD_SOUND_Play(c->pGame->c->DefineSound[c->pGame->GetCorrectSoundNumber(48)].strFilename, 1);
	}
}

void GameFunc_StrafeLeft(CCtrlGame *c)
{
	int xvect;
	int zvect;
	short s;
	xvect = (-SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2560 + 512)&2047))>>3;
	zvect = (-SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2048 + 512)&2047))>>3;
	s = XBUILD_ANIMATE_GetCurrentSector();
	c->pGame->Y <<= 4;
	XBUILD_ANIMATE_ClipMove((long*)&c->pGame->X, (long*)&c->pGame->Z, (long*)&c->pGame->Y, &s, xvect, zvect, 128, DUKECDIST, DUKEFDIST, CLIPMASK0);
	c->pGame->Y >>= 4;
}

void GameFunc_StrafeRight(CCtrlGame *c)
{
	int xvect;
	int zvect;
	short s;
	xvect = (SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2560 + 512)&2047))>>3;
	zvect = (SPEED*(long)XBUILD_ANIMATE_GetValueFromSinTable((c->pGame->YAngle+2048 + 512)&2047))>>3;
	s = XBUILD_ANIMATE_GetCurrentSector();
	c->pGame->Y <<= 4;
	XBUILD_ANIMATE_ClipMove((long*)&c->pGame->X, (long*)&c->pGame->Z, (long*)&c->pGame->Y, &s, xvect, zvect, 128, DUKECDIST, DUKEFDIST, CLIPMASK0);
	c->pGame->Y >>= 4;
}

void GameFunc_AimUp(CCtrlGame *c)
{
	c->pGame->XAngle -= 30;
}

void GameFunc_AimDown(CCtrlGame *c)
{
	c->pGame->XAngle += 30;
}

static void (*KeyboardFunctions[CONTROLCOUNT])(CCtrlGame*) =
{
	GameFunc_MoveForward,
	GameFunc_MoveBackward,
	GameFunc_TurnLeft,
	GameFunc_TurnRight,
	GameFunc_Strafe,
	GameFunc_Fire,
	GameFunc_Open,
	GameFunc_Run,
	NULL,
	GameFunc_Jump,
	GameFunc_Crouch,
	NULL,
	NULL,
	NULL,
	NULL,
	GameFunc_StrafeLeft,
	GameFunc_StrafeRight,
	GameFunc_AimUp,
	GameFunc_AimDown,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

void CCtrlGame::AdjustHeight()
{
	int a;
	if(pGame->nUnderwater)
	{
		return;
	}
	a = XBUILD_ANIMATE_GetCurrentSector();
	if(!nJumping)
	{
		if(pGame->Y != XBUILD_ANIMATE_GetFloorHeight(a, pGame->X, pGame->Z) - 500 && !(pGame->pMap->Sector[a].FStat & 2))
		{
			nJumpingHeight = pGame->Y;
			nFalling = 1;
			nJumping = 1;
			nJumpingIncrem = XBUILD_INCREMENTATOR_Add(&nJumpingHeight, 4, (XBUILD_ANIMATE_GetFloorHeight(a, pGame->X, pGame->Z) - 500), NULL, NULL);
			nJumpingSector = a;
			nJumpingNoSound = 1;
		}
		else
		{
			pGame->Y = XBUILD_ANIMATE_GetFloorHeight(a, pGame->X, pGame->Z) - 500;
		}
	}
	else
	{
		if((nJumpingSector != a) && nFalling && !XBUILD_INCREMENTATOR_IsIncrementDead(nJumpingIncrem))
		{
			XBUILD_INCREMENTATOR_SetMaxValue(nJumpingIncrem, (XBUILD_ANIMATE_GetFloorHeight(a, pGame->X, pGame->Z) - 500));
			nJumpingSector = a;
		}
		pGame->Y = nJumpingHeight;
		if(XBUILD_INCREMENTATOR_IsIncrementDead(nJumpingIncrem) && nJumping && !nFalling)
		{
			nJumpingIncrem = XBUILD_INCREMENTATOR_Add(&nJumpingHeight, 4, (XBUILD_ANIMATE_GetFloorHeight(a, pGame->X, pGame->Z) - 500), NULL, NULL); 
			nFalling = 1;
			nJumpingSector = a;
		}
		else if(nJumping && nFalling && XBUILD_INCREMENTATOR_IsIncrementDead(nJumpingIncrem))
		{
			nFalling = 0;
			nJumping = 0;
			pGame->Y = XBUILD_ANIMATE_GetFloorHeight(a, pGame->X, pGame->Z) - 500;
			//Change this!
			if(!nJumpingNoSound)
			{
				XBUILD_SOUND_Play("land02.voc", 0);
			}
			nJumpingNoSound = 0;
		}
	}
}

void CCtrlGame::PassControlFocus(CGame *g)
{
	pGame = g;
	pGame->nControlFocus = CONTROL_FOCUS_GAME;
}

void CCtrlGame::Update()
{
	int i;
	if(set.m_Setup.dwControlStatus & 0x01)
	{
		pGame->diw.UpdateKeyboardData();
		if(nCheckKey != 0)
		{
			if(!(pGame->diw.lpKeyboardData[nCheckKey] & 0x80))
			{
				nCheckKey = 0;
			}
			else
			{
				pGame->diw.lpKeyboardData[nCheckKey] &= ~0x80;
			}
		}
		if(pGame->diw.lpKeyboardData[DIK_ESCAPE] & 0x80)
		{
			//Should trigger the menu
			pGame->nQuit = 1;
		}
		if(pGame->diw.lpKeyboardData[DIK_C] & 0x80)
		{
			nCheckKey = DIK_C;
			nClipping = !nClipping;
			if(nClipping)
			{
				pGame->PrintTextOnStatus("No clipping mode off");
			}
			else
			{
				pGame->PrintTextOnStatus("No clipping mode on");
			}
		}
		if(pGame->diw.lpKeyboardData[DIK_GRAVE] & 0x80)
		{
			((CCtrlConsole*)pGame->pCtrlConsole)->PassControlFocus(pGame);
			((CCtrlConsole*)pGame->pCtrlConsole)->nCheckKey = DIK_GRAVE;
		}
		if(pGame->diw.lpKeyboardData[DIK_F1] & 0x80)
		{
			nCheckKey = DIK_F1;
			XBUILD_RTSMANAGER_Play(0);
		}
		if(pGame->diw.lpKeyboardData[DIK_F2] & 0x80)
		{
			nCheckKey = DIK_F2;
			XBUILD_RTSMANAGER_Play(1);
		}
		if(pGame->diw.lpKeyboardData[DIK_F3] & 0x80)
		{
			nCheckKey = DIK_F3;
			XBUILD_RTSMANAGER_Play(2);
		}
		if(pGame->diw.lpKeyboardData[DIK_F4] & 0x80)
		{
			nCheckKey = DIK_F4;
			XBUILD_RTSMANAGER_Play(3);
		}
		if(pGame->diw.lpKeyboardData[DIK_F5] & 0x80)
		{
			nCheckKey = DIK_F5;
			XBUILD_RTSMANAGER_Play(4);
		}
		if(pGame->diw.lpKeyboardData[DIK_F6] & 0x80)
		{
			nCheckKey = DIK_F6;
			XBUILD_RTSMANAGER_Play(5);
		}
		if(pGame->diw.lpKeyboardData[DIK_F7] & 0x80)
		{
			nCheckKey = DIK_F7;
			XBUILD_RTSMANAGER_Play(6);
		}
		if(pGame->diw.lpKeyboardData[DIK_F8] & 0x80)
		{
			nCheckKey = DIK_F8;
			XBUILD_RTSMANAGER_Play(7);
		}
		if(pGame->diw.lpKeyboardData[DIK_F9] & 0x80)
		{
			nCheckKey = DIK_F9;
			XBUILD_RTSMANAGER_Play(8);
		}
		if(pGame->diw.lpKeyboardData[DIK_F10] & 0x80)
		{
			nCheckKey = DIK_F10;
			XBUILD_RTSMANAGER_Play(9);
		}
		if(pGame->diw.lpKeyboardData[DIK_F11] & 0x80)
		{
			nCheckKey = DIK_F11;
			pGame->TakeScreenShot();
		}
		for(i = 0; i < CONTROLCOUNT - 1; i++)
		{
			if(pGame->diw.lpKeyboardData[set.m_Setup.nControls[i]] & 0x80)
			{
				if(KeyboardFunctions[i] != NULL)
				{
					KeyboardFunctions[i](this);
				}
			}
		}
	}
	if(set.m_Setup.dwControlStatus & 0x02)
	{
		pGame->diw.UpdateMouseData();
		pGame->XAngle += pGame->diw.MouseState.lY / 2;
		pGame->YAngle += pGame->diw.MouseState.lX;
	}
	AdjustHeight();
}