// Game.h: interface for the CGame class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAME_H__D21EFEE0_2DA8_11D5_AEF3_0048548C5440__INCLUDED_)
#define AFX_GAME_H__D21EFEE0_2DA8_11D5_AEF3_0048548C5440__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\XBUILD\XBUILD.H"
#include "DIWRAPPER.H"

#define CONTROL_FOCUS_GAME		0x01
#define CONTROL_FOCUS_CONSOLE	0x02
#define CONTROL_FOCUS_MENU		0x03

struct GAME_SECTORSTATUS
{
	unsigned _int8	bActivated;
	int				nSector;
	int				nIncrementator;
	void*			pGame;
};

class CGame  
{
public:
	CGame();
	virtual ~CGame();
	void	AdjustHeight();
	void	BeginLoop();
	void	CompileCONs();
	void	ChangeHealth(int);
	int		GetCorrectSoundNumber(int);
	int		IsBuiltInLevel();
	void	PrintTextOnStatus(char*);
	void	ProcessMap();
	void	ProcessSectorTags();
	void	PlayCorrectMusic();
	void	SetupMod();
	void	UpdateAmbientSounds();
	int		ActivateSectorEffector(int, int);
	int		ActivateSectorTag(int, int);
	void	TakeScreenShot();
	//Variables
	unsigned int				m_nStatusTimer;
	CString						m_Level;
	XBUILDDISPLAYLIST			m_Status;
	XBUILDDISPLAYLIST			m_Console;
	XBUILD_CONSCRIPT_CONTEXT*	c;
	XBUILD_MAP*					pMap;
	int							nCheckKey;
	int							nConsole;
	int							nUserLevel;
	HWND						m_hWnd;
	//Game variables
	int							nHealth;
	int							nWeaponsAmmo[12];
	//Variables to keep
	int							nControlFocus;
	int							nQuit;
	int							nUnderwater;
	int							X;
	int							Y;
	int							Z;
	int							XAngle;
	int							YAngle;
	DIWRAPPER					diw;
	void*						pCtrlGame;
	void*						pCtrlConsole;
	int							nAmbiants[512];
	int							nAmbiantsSprites[512];
	int							nAmbiantCount;
	char						strGRP[64];
	char						strCON[64];
	GAME_SECTORSTATUS			SectorStatus[MAXSECTORS];
};

#endif // !defined(AFX_GAME_H__D21EFEE0_2DA8_11D5_AEF3_0048548C5440__INCLUDED_)
