// Movie.cpp: implementation of the CMovie class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "glDuke.h"
#include "Movie.h"
#include "..\XBUILD\XBUILD.H"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


void DecodeFrame(CMovie *pMovie)
{
	int i, LPNum;
	LPHEADER h;
	LPNum = 0;
	unsigned _int16 *pRec;
	unsigned _int16 wTemp;
	unsigned _int32 dwTemp;
	unsigned _int8	bTemp;
	unsigned _int8*	pBuffer;
	unsigned _int16 nCount;
	unsigned _int16	nPixel;
	int				nDone;
	int nRecSize;
	for(i = 1; i != (pMovie->header.LPS); i++)
	{
		if((pMovie->tmpLP[i].BaseRecord <= pMovie->nFrameNum) && (pMovie->tmpLP[i].BaseRecord + pMovie->tmpLP[i].Records) > pMovie->nFrameNum)
		{
			LPNum = i;
		}
	}
	fseek(pMovie->pStream, pMovie->LPOffset[LPNum + 1], SEEK_SET);
	fread(&h, sizeof(LPHEADER), 1, pMovie->pStream);
	fread(&wTemp, 2, 1, pMovie->pStream);
	pRec = new unsigned _int16[h.Records];
	fread(pRec, h.Records * 2, 1, pMovie->pStream);
	dwTemp = ftell(pMovie->pStream);
	if(pMovie->nFrameNum != 0)
	{
		for(i = h.BaseRecord; i < pMovie->nFrameNum; i++)
		{
			dwTemp += pRec[i - h.BaseRecord];
		}
	}
	nRecSize = pRec[pMovie->nFrameNum - h.BaseRecord];
	fseek(pMovie->pStream, dwTemp, SEEK_SET);
	fread(&bTemp, 1, 1, pMovie->pStream);
	if(bTemp != 66)
	{
		return;
	}
	fread(&bTemp, 1, 1, pMovie->pStream);
	if(bTemp != 0)
	{
		return;
	}
	fread(&wTemp, 2, 1, pMovie->pStream);
	if(wTemp != 1)
	{
		return;
	}
	//I added that...
	if(nRecSize == 0)
	{
		pMovie->nFinished = 1;
		delete pRec;
		return;
	}
	nRecSize -= 4;
	pBuffer = new unsigned _int8[nRecSize];
	fread(pBuffer, nRecSize, 1, pMovie->pStream);
	//Decoding frame here
	nCount = 0;
	nPixel = 0;
	nDone = 0;
	while(!nDone)
	{
		bTemp = pBuffer[nCount++];
		if(bTemp & 0x80)
		{
			bTemp &= 0x7F;
			if(bTemp == 0x00)
			{
				wTemp = *(unsigned _int16*)&pBuffer[nCount];
				nCount += 2;
				if(wTemp & 0x8000)
				{
					wTemp &= 0x7FFF;
					if(wTemp >= 0x4000)
					{
						wTemp -= 0x4000;
						for(i = 0; i < wTemp; i++)
						{
							//Plot pixel
							pMovie->pFrameBuffer[nPixel++] = pBuffer[nCount];
						}
						nCount++;
					}
					else
					{
						for(i = 0; i < wTemp; i++)
						{
							//Plot pixel
							pMovie->pFrameBuffer[nPixel++] = pBuffer[nCount++];
						}
					}
				}
				else if(wTemp > 0x0000)
				{
					nPixel += wTemp;
				}
				else if(wTemp == 0x0000)
				{
					nDone = 1;
				}
			}
			else
			{
				nPixel += bTemp;
			}
		}
		else if(bTemp > 0)
		{
			for(i = 0; i < bTemp; i++)
			{
				//Plot Pixels
				pMovie->pFrameBuffer[nPixel++] = pBuffer[nCount++];
			}
		}
		else
		{
			bTemp = pBuffer[nCount++];
			for(i = 0; i < bTemp; i++)
			{
				//Plot pixels
				pMovie->pFrameBuffer[nPixel++] = pBuffer[nCount];
			}
			nCount++;
		}
	}
	delete pBuffer;
	delete pRec;
	pMovie->nFrameNum++;
	if(pMovie->nFrameNum == (pMovie->header.Frames - 1))
	{
		pMovie->nFinished = 1;
		if((pMovie->header.Loop) && (!pMovie->header.LoopValid))
		{
			pMovie->nFrameNum = 0;
		}
	}
	if(pMovie->nFrameNum == (pMovie->header.Frames))
	{
		pMovie->nFinished = 1;
		if(pMovie->header.Frames == 1)
		{
			pMovie->nFrameNum = 0;
		}
		else if(pMovie->header.LoopValid == 1)
		{
			pMovie->nFrameNum = 1;
		}
		else
		{
			pMovie->nFrameNum = 0;
		}
	}
}

void SendFrameToRenderer(CMovie *pMovie)
{
	int i;
	unsigned _int8 R;
	unsigned _int8 G;
	unsigned _int8 B;
	for(i = 0; i < (320 * 200); i++)
	{
		R = pMovie->palette[pMovie->pFrameBuffer[i]].R;
		G = pMovie->palette[pMovie->pFrameBuffer[i]].G;
		B = pMovie->palette[pMovie->pFrameBuffer[i]].B;
		pMovie->pRendererBuffer[i] = 0xFF000000 | R | (G << 8) | (B << 16);
	}
}

unsigned long WINAPI ThreadMoviePlay(void *pData)
{
	CMovie *m;
	XBUILDDISPLAYLIST dl;
	XBUILDDISPLAYELEMENT_32BITS e;
	m = (CMovie*)pData;
	m->pRendererBuffer = new unsigned _int32[320 * 200];
	dl.nElementCount = 1;
	dl.dwReferentialX = 320;
	dl.dwReferentialY = 200;
	dl.Element[0].dwType = XBUILDDISPLAYLIST_TYPE_32BITS;
	e.dwX = 0;
	e.dwY = 0;
	e.pStream = (char*)m->pRendererBuffer;
	memcpy(dl.Element[0].pData, &e, sizeof(XBUILDDISPLAYELEMENT_32BITS));
	XBUILD_GFX_SetDisplayList(XBUILD_GFX_LAYER_STATUS, &dl);
	while(1)
	{
		DecodeFrame(m);
		SendFrameToRenderer(m);
		Sleep(1000 / m->header.FramesPerSecond); 
		if(m->nFinished)
		{
			XBUILD_GFX_SetStatus(0x00000000);
			break;
		}
	}
	e.pStream = NULL;
	memcpy(dl.Element[0].pData, &e, sizeof(XBUILDDISPLAYELEMENT_32BITS));
	XBUILD_GFX_SetDisplayList(XBUILD_GFX_LAYER_STATUS, &dl);
	delete m->pRendererBuffer;
	return 0xDEADBEEF;
}


CMovie::CMovie()
{
	nFrameNum = 0;
	nFinished = 0;
}

CMovie::~CMovie()
{

}

void CMovie::PlayANM(char *strFile)
{
	int i;
	XBUILD_GFX_SetStatus(XBUILD_GFX_LAYER_STATUS);
	XBUILD_GRPMANAGER_ExtractFile(strFile, "MVSTEMP.ANM");
	pStream = fopen("MVSTEMP.ANM", "rb");
	fread(&header, sizeof(ANMHEADER), 1, pStream);
	fread(palette, sizeof(ANMPALETTE) * 256, 1, pStream);
	fread(tmpLP, sizeof(LPHEADER) * 256, 1, pStream);
	LPOffset = new unsigned _int32[header.LPS + 1];
	for(i = 0; i < header.LPS; i++)
	{
		LPOffset[i + 1] = ftell(pStream) + (0x10000 * i);
	}
	pFrameBuffer = new unsigned _int8[320 * 200];
	hThread = CreateThread(NULL, NULL, ThreadMoviePlay, this, NULL, &dwTID);
	WaitForSingleObject(hThread, INFINITE);
	fclose(pStream);
	delete LPOffset;
	delete pFrameBuffer;
	DeleteFile("MVSTEMP.ANM");
}