// RendererOpt.cpp : implementation file
//

#include "stdafx.h"
#include "glDuke.h"
#include "RendererOpt.h"
#include "Renderer.h"
#include "Settings.h"

extern CSettings set;
RENDERER Rend;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRendererOpt dialog


CRendererOpt::CRendererOpt(CWnd* pParent /*=NULL*/)
	: CDialog(CRendererOpt::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRendererOpt)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CRendererOpt::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRendererOpt)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRendererOpt, CDialog)
	//{{AFX_MSG_MAP(CRendererOpt)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_CONFIG, OnConfig)
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRendererOpt message handlers

BOOL CRendererOpt::OnInitDialog() 
{
	CDialog::OnInitDialog();
	RENDERERINFO renders;
	char lpTemp[256];
	int i = 0;
	int nItem = 0;
	int nRet;
	// TODO: Add extra initialization here
	while(1)
	{
		nRet = Rend.GetAvaliableRenderers(&renders, i);
		if(nRet == 1)
		{
			memset(lpTemp, 0, 256);
			sprintf(lpTemp, "%s %s %s (%s)", renders.Author, renders.Description, renders.Version, renders.Filename);
			SendDlgItemMessage(IDC_RENDERER, CB_ADDSTRING, NULL, (LPARAM)lpTemp);
			SendDlgItemMessage(IDC_RENDERER, CB_SETITEMDATA, nItem++, (LPARAM)i);
		}
		else if(nRet == 2)
		{
			GetParent()->SendMessage(WM_COMMAND, 2, 0);
			return 0;
		}
		else
		{
			break;
		}
		i++;
	}
	if(!strnicmp(set.m_Setup.lpstrRenderer, " ", strlen(" ")))
	{
		Rend.GetAvaliableRenderers(&renders, 0);
		memmove(set.m_Setup.lpstrRenderer, renders.Filename, strlen(renders.Filename) + 1);
	}
	for(i = 0; i < SendDlgItemMessage(IDC_RENDERER, CB_GETCOUNT, 0, 0); i++)
	{
		nItem = SendDlgItemMessage(IDC_RENDERER, CB_GETITEMDATA, i, NULL);
		nRet = Rend.GetAvaliableRenderers(&renders, nItem);
		if(nRet == 1)
		{
			if(!stricmp(renders.Filename, set.m_Setup.lpstrRenderer))
			{
				SendDlgItemMessage(IDC_RENDERER, CB_SETCURSEL, i, 0);
			}
		}
		else
		{
			break;
		}
	}
	ChangeSelection(set.m_Setup.lpstrRenderer);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRendererOpt::ChangeSelection(char *lpstrDLL)
{
	char lpTemp[256];
	XBUILDRENCONTEXT c;
	if(!Rend.GetRendererContext(lpstrDLL, &c, NULL))
	{
		RENDERERINFO renders;
		Rend.GetAvaliableRenderers(&renders, 0);
		memmove(set.m_Setup.lpstrRenderer, renders.Filename, strlen(renders.Filename) + 1);
		ChangeSelection(set.m_Setup.lpstrRenderer);
		return;
	}
	memmove(set.m_Setup.lpstrRenderer, lpstrDLL, strlen(lpstrDLL) + 1);
	memset(lpTemp, 0, 256);
	sprintf(lpTemp, "%s %s %s (%s)", c.Author, c.Description, c.Version, set.m_Setup.lpstrRenderer);
	SetDlgItemText(IDC_CURRREND, lpTemp);
}

void CRendererOpt::OnAbout() 
{
	// TODO: Add your control notification handler code here
	int sel;
	HMODULE hMod;
	RENDERERINFO inf;
	XBUILDRENCONTEXT c;
	sel = SendDlgItemMessage(IDC_RENDERER, CB_GETCURSEL);
	Rend.GetAvaliableRenderers(&inf, sel);
	Rend.GetRendererContext(inf.Filename, &c, &hMod);
	c.About();
	FreeLibrary(hMod);
}

void CRendererOpt::OnConfig() 
{
	// TODO: Add your control notification handler code here
	int sel;
	RENDERERINFO inf;
	HMODULE hMod;
	XBUILDRENCONTEXT c;
	sel = SendDlgItemMessage(IDC_RENDERER, CB_GETCURSEL);
	Rend.GetAvaliableRenderers(&inf, sel);
	Rend.GetRendererContext(inf.Filename, &c, &hMod);
	c.Config();
	FreeLibrary(hMod);
}

void CRendererOpt::OnSelect() 
{
	// TODO: Add your control notification handler code here
	int sel;
	RENDERERINFO inf;
	sel = SendDlgItemMessage(IDC_RENDERER, CB_GETCURSEL);
	Rend.GetAvaliableRenderers(&inf, sel);
	ChangeSelection(inf.Filename);
}
