#include "COMMON.H"

//ART loading process might be slow the first time, but level changing
//don't takes any loading time...

#define MAXTILES 9216

TILEDATA			ART_Tiles[MAXTILES];
unsigned _int8*		ART_lpTiles;
unsigned _int8*		ART_lpPalette;

int ART_CalculateNeededMemory()
{
	char artfile[15];
	unsigned _int8 *tiles;
	unsigned _int32 size;
	unsigned _int32 tsize = 0;
	int artfilenumber = 0;
	while(1)
	{
		sprintf(artfile, "TILES%0.3i.ART", artfilenumber);
		if(!XBUILD_GRPMANAGER_GetFileData(artfile, &tiles, &size))
		{
			//DONE!
			break;
		}
		tsize += size;
		artfilenumber++;
		delete tiles;
	}
	return tsize;
}

extern "C" int DLLEXPORT XBUILD_ART_Initialize()
{
	unsigned _int32 abstilenumber = 0;
	unsigned _int32 abstileaddr = 0;
	unsigned _int32 lineardataptr = 0;
	unsigned _int32 localtilestart;
	unsigned _int32 localtileend;
	unsigned _int32 tilenum;
	unsigned _int8 *tiles;
	unsigned _int32 currpos = 0;
	unsigned _int32 i;
	char artfile[15];
	int artfilenumber = 0;
	unsigned _int32 size;
	XBUILD_CONSOLE_PrintFormatted("Loading Art... (this may take a while)\r\n");	
	ART_lpTiles = new unsigned _int8[ART_CalculateNeededMemory()];
	while(1)
	{
		sprintf(artfile, "TILES%0.3i.ART", artfilenumber);
		if(!XBUILD_GRPMANAGER_GetFileData(artfile, &tiles, &size))
		{
			//DONE!
			break;
		}
		if((GETLONG(tiles, 0x00)) != 1)
		{
			return 0;
			break;
		}
		localtilestart = GETLONG(tiles, 0x08);
		localtileend = GETLONG(tiles, 0x0C);
		tilenum = localtileend - localtilestart + 1;
		currpos = 0x10;
		for(i = 0; i < tilenum; i++)
		{
			ART_Tiles[i + localtilestart].Width = GETWORD(tiles, currpos);
			currpos += 2;
		}
		for(i = 0; i < tilenum; i++)
		{
			ART_Tiles[i + localtilestart].Height = GETWORD(tiles, currpos);
			currpos += 2;
		}
		for(i = 0; i < tilenum; i++)
		{
			ART_Tiles[i + localtilestart].Attributes = GETLONG(tiles, currpos);
			currpos += 4;
		}
		for(i = 0; i < tilenum; i++)
		{
			ART_Tiles[i + localtilestart].Address = abstileaddr;
			abstileaddr += ART_Tiles[i + localtilestart].Width * ART_Tiles[i + localtilestart].Height;
		}
		//Move the graphics data
		memcpy(ART_lpTiles + lineardataptr, tiles + currpos, size - currpos);
		lineardataptr += size - currpos;
		artfilenumber++;
		currpos = 0;
		delete tiles;
	}
	XBUILD_GRPMANAGER_GetFileData("PALETTE.DAT", &tiles, &size);
	ART_lpPalette = new unsigned _int8[size];
	memcpy(ART_lpPalette, tiles, size);
	delete tiles;
	return 1;
}

extern "C" void DLLEXPORT XBUILD_ART_GetTileData(int nTile, XBUILD_ART_TILEDATA *lpTile)
{
	lpTile->Width = ART_Tiles[nTile].Width;
	lpTile->Height = ART_Tiles[nTile].Height;
	lpTile->Attributes = ART_Tiles[nTile].Attributes;
	lpTile->lpData = new unsigned _int8[lpTile->Width * lpTile->Height];
	memmove(lpTile->lpData, ART_lpTiles + ART_Tiles[nTile].Address, lpTile->Width * lpTile->Height);
}

extern "C" void DLLEXPORT XBUILD_ART_GetTileDimensions(int nTile, unsigned short *x, unsigned short *y)
{
	*x = ART_Tiles[nTile].Width;
	*y = ART_Tiles[nTile].Height;
}

extern "C" void DLLEXPORT XBUILD_ART_GetPalette(void *lpData)
{
	memcpy(lpData, ART_lpPalette, 0x300);
}

extern "C" void DLLEXPORT XBUILD_ART_Destroy()
{
	delete ART_lpTiles;
	delete ART_lpPalette;
}

