#include "COMMON.H"

#define				INCREMENT_MAX 32
XBUILD_INCREMENT*	INCREMENTATOR_pIncrements = NULL;
int					INCREMENTATOR_nCount = 0;

void INCREMENTATOR_Kill(int nEntry)
{
	memset(&INCREMENTATOR_pIncrements[nEntry], 0, sizeof(XBUILD_INCREMENT));
	INCREMENTATOR_nCount--;
}

void INCREMENTATOR_Update(int nMs)
{
	XBUILD_INCREMENT *inc;
	int i, nCount;
	nCount = INCREMENTATOR_nCount;
	for(i = 0; i < INCREMENT_MAX; i++)
	{
		if(nCount == 0) break;
		inc = &INCREMENTATOR_pIncrements[i];
		if(!inc->nAlive) continue;
		*(inc->pValue) += inc->nUnitsPerSlice * nMs;
		if(inc->nUnitsPerSlice & 0x80000000)
		{
			if(*(inc->pValue) < inc->nMaxValue)
			{
				*(inc->pValue) = inc->nMaxValue;
				if(inc->Callback != NULL)
				{
					inc->Callback(inc->pCbdata);
				}
				INCREMENTATOR_Kill(i);
			}
		}
		else
		{
			if(*(inc->pValue) > inc->nMaxValue)
			{
				*(inc->pValue) = inc->nMaxValue;
				if(inc->Callback != NULL)
				{
					inc->Callback(inc->pCbdata);
				}
				INCREMENTATOR_Kill(i);
			}
		}
		nCount--;
	}
}

extern "C" void DLLEXPORT XBUILD_INCREMENTATOR_Update()
{
	static int dwTicks = 0;
	int dTicks = 0;
	if(dwTicks == 0)
	{
		dwTicks = GetTickCount();
	}
	while(dTicks < 1)
	{
		dTicks = GetTickCount() - dwTicks;
	}
	INCREMENTATOR_Update(dTicks);
	dwTicks = GetTickCount();
}

extern "C" void DLLEXPORT XBUILD_INCREMENTATOR_Initialize()
{
	INCREMENTATOR_pIncrements = new XBUILD_INCREMENT[INCREMENT_MAX];
	memset(INCREMENTATOR_pIncrements, 0, sizeof(XBUILD_INCREMENT) * INCREMENT_MAX);
}

extern "C" void DLLEXPORT XBUILD_INCREMENTATOR_Destroy()
{
	delete INCREMENTATOR_pIncrements;
}

int INCREMENTATOR_GetNextSpot()
{
	int i;
	for(i = 0; i < INCREMENT_MAX; i++)
	{
		if(INCREMENTATOR_pIncrements[i].nMaxValue == 0)
		{
			return i;
		}
	}
	return -1;
}

int INCREMENTATOR_Append(XBUILD_INCREMENT *pInc)
{
	int nSpot;
	nSpot = INCREMENTATOR_GetNextSpot();
	if(nSpot == -1)
	{
		return -1;
	}
	memcpy(&INCREMENTATOR_pIncrements[nSpot], pInc, sizeof(XBUILD_INCREMENT));
	INCREMENTATOR_nCount++;
	return nSpot;
}

extern "C" void DLLEXPORT XBUILD_INCREMENTATOR_SetMaxValue(int nInc, int nMaxValue)
{
	INCREMENTATOR_pIncrements[nInc].nMaxValue = nMaxValue;
}

extern "C" int DLLEXPORT XBUILD_INCREMENTATOR_IsIncrementDead(int nInc)
{
	if(INCREMENTATOR_pIncrements[nInc].pValue == NULL)
	{
		return 1;
	}
	return 0;
}

extern "C" int DLLEXPORT XBUILD_INCREMENTATOR_Add(int *pValue, int nUnitsPerSlice, int nMaxValue, void *Callback, void *pCallbackData)
{
	XBUILD_INCREMENT b;
	b.pValue = pValue;
	b.nUnitsPerSlice = nUnitsPerSlice;
	b.nMaxValue = nMaxValue;
	b.nAlive = 1;
	b.Callback = (void (*)(void*))Callback;
	b.pCbdata = pCallbackData;
	return INCREMENTATOR_Append(&b);
}