//*****************************************************//
//xBUILD Engine Source Code                            //
//*****************************************************//
//Original BUILD Engine idea: Ken Silverman            //
//xBUILD Author: Jean-Philip Desjardins                //
//*****************************************************//
//You can't use any part of this source code if you    //
//haven't been granted the permission to do so.        //
//DO NOT DISTRIBUTE!                                   //
//*****************************************************//
// 2000 Virtual Applications, All rights reserved     //
//*****************************************************//

#include "COMMON.H"

HANDLE	XBUILD_hMod;

void msgboxf(HWND hWnd, char *lpstrTitle, int nType, const char *format, ...)
{
	char string[256];
	memset(string, 0, 256);
	va_list args;
	va_start(args, format);
	vsprintf(string, format, args);
	va_end(args);
	MessageBox(hWnd, string, lpstrTitle, nType);
}

extern "C" int DLLEXPORT XBUILD_Initialize(char *GRPFILE, char *RTSFILE)
{
	XBUILD_CONSOLE_Clear();
	XBUILD_CONSOLE_PrintFormatted("Initializing the xBUILD Engine...\r\n");
	XBUILD_CONSOLE_PrintFormatted("Copyright 2000/2001/2002 Virtual Applications.\r\n");
	XBUILD_CONSOLE_PrintFormatted("Built on: %s.\r\n", __DATE__);
	if(!GRPMANAGER_SetMainFile(GRPFILE))
	{
		return 0;
	}
	if(!RTSMANAGER_SetMainFile(RTSFILE))
	{
		return 0;
	}
	return 1;
}

BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	XBUILD_hMod = hModule;
	return TRUE;
}
